﻿function ContentParser(options) {
  var settings = $.extend(
    {
      screenSettings: null,
    },
    options
  );
  var interactivity;
  if (settings.screenSettings == null || settings.screenSettings.interactivity == null) {
    interactivity = {
      screenId: -1,
      commandPath: null,
      BookingEnabled: true,
      ConfirmationEnabled: true,
      ReschedulingEnabled: true,
      ConfirmationInAdvanceLimit: 15,
      ConfirmationDeadlineLimit: 5,
      preparationTime: 15,
    };
  } else {
    interactivity = settings.screenSettings.interactivity;
  }

  var localizer;
  if (settings.screenSettings == null || settings.screenSettings.localization == null) {
    localizer = {
      Capacity: "Capacity",
      Description: "Description",
      Attributes: "Attributes",
      TableSetups: "Table setups",
      Standard: "Standard",
      WeekSchema: "Week schema",
      AllDay: "All day",
      Availability: "Availability",
      FollowUpTime: "Follow up time",
      PreparationTime: "Preparation time",
      Unavailable: "Unavailable",
      ScreenEndNow: "End now",
      ScreenBookNow: "Book now",
      ScreenReschedule: "Edit end time",
      ScreenConfirm: "Confirm",
      NoUpcomingMeetings: "No upcoming meetings",
      Next: "Next",
      NextMeeting: "Next meeting",
      Available: "Available",
      AvailableNext: "Available next",
      ClosedUntil: "Closed until",
      ClosedForTheRestOfTheDay: "Closed for the rest of the day",
      ServiceOfRoom: "Service of room",
      AvailableForTheRestOfTheDay: "Available for the rest of the day",
      EndsIn: "Ends in",
      MinutesShort: "min",
      HourShort: "h",
      Time: "Time",
      Owner: "Owner",
      Phone: "Phone",
      MobilePhone: "Mobile phone",
      Contact: "Contact",
      Participants: "Participants",
      MeetingType: "Meeting type",
      NoDetails: "No details available",
      Details: "Show details",
      MeetingBy: "Meeting by",
      TechnicalDetails: "Technical Details",
      ErrorOccurredTryingToResolve: "Error has occured, trying to resolve the problem",
      MeetingConfirmed: "Meeting confirmed",
      LicensedTo: "Licensed to",
      PoweredBy: "Powered by",
      ScreenConfirmHeader: "Confirm",
      ScreenConfirmEndMeeting: "End meeting now?",
      ScreenChooseEndTimeHeader: "Choose end time",
      ScreenRescheduleHeader: "Choose new end time",
      Cancel: "Cancel",
      OK: "OK",
      ScreenMessageHeader: "Message",
      Monday: "Monday",
      Tuesday: "Tuesday",
      Wednesday: "Wednesday",
      Thursday: "Thursday",
      Friday: "Friday",
      Saturday: "Saturday",
      Sunday: "Sunday",
      Yes: "Yes",
      No: "No",
      SpontaneousMeeting: "Spontaneous meeting",
      CannotBookRoom: "Cannot book room it is already booked {0}",
      CannotRescheduleRoom: "Cannot change end time the room is already booked {0}",
      ExtendMeeting: "Extend Meeting",
      EndMeeting: "End Meeting",
      BookNow: "Book Now",
      About: "About",
      CurrentMeeting: "Current Meeting",
      Organizer: "Organizer",
      Period: "Period",
      Current: "Current",
      InteractivityNotEnabled: "Interactivity is not enabled for screen with id &#39;{0}&#39;",
      BookingInteractivityNotEnabled: "Booking interactivity is not enabled for screen with id &#39;{0}&#39;",
      ConfirmInteractivityNotEnabled: "Confirm interactivity is not enabled for screen with id &#39;{0}&#39;",
      RescheduleInteractivityNotEnabled: "Reschedule interactivity is not enabled for screen with id &#39;{0}&#39;",
      ServiceAccountNotAuthorizedForFeature:
        "The service account is not authorized to perform the interaction feature you requested",
      AnErrorHasOccurred: "An error has occurred. We are sorry for the inconvenience.",
      MeetingsToday: "Meetings today",
      PrivateMeeting: "Private meeting",
      Sun: "Sun",
      Mon: "Mon",
      Tue: "Tue",
      Wed: "Wed",
      Thu: "Thu",
      Fri: "Fri",
      Sat: "Sat",
      Jan: "Jan",
      Feb: "Feb",
      Mar: "Mar",
      Apr: "Apr",
      May: "May",
      Jun: "Jun",
      Jul: "Jul",
      Aug: "Aug",
      Sep: "Sep",
      Oct: "Oct",
      Nov: "Nov",
      Dec: "Dec",
      January: "January",
      February: "February",
      March: "March",
      April: "April",
      MayFull: "May",
      June: "June",
      July: "July",
      August: "August",
      September: "September",
      October: "October",
      November: "November",
      December: "December",
      RoomDescription: "Room description",
      AvailableFrom: "Available from",
      OccupiedFrom: "Occupied from",
      To: "To",
      HoursLeftFormat: "{0} h",
      MinutesLeftFormat: "{0} min",
      HoursAndMinuteLeftFormat: "{0} h and {1} min",
      Back: "Back",
      Search: "Search",
      EndsInWithTime: "Ends in {0}",
      AvailableNextWithTime: "Available next {0}",
      MeetingInformation: "Meeting info",
      ErrorReportIssueSolved: "The error is Fixed and the report has been canceled",
      ErrorReportIssueSolvedHeader: "Problem solved",
      ErrorReportSentHeader: "Thank you",
      PleaseEnterPinCode: "Please enter pin-code",
      WrongPinCode: "Wrong pin-code",
      Email: "Email",
      StartsIn: "Starts in",
    };
  } else {
    localizer = settings.screenSettings.localization;
  }
  var screenSettings = settings.screenSettings;
  var statusArray = { free: "free", busy: "busy" };
  /*primary methods*/
  function isPrimaryBusy(item) {
    return item.Type === "Busy" || item.Type === "BusyHidden";
  }

  function isPrimaryFree(item) {
    return item.Type === "Free" || item.Type === "FreeAllDay";
  }

  function getFree(item, secondary) {
    var jsonObj = extractBase(item, secondary);
    $.extend(jsonObj, {
      Title: localizer.Available,
      Period: getAvailableFor(item.HoursLeft, item.MinutesLeft),
      Status: statusArray.free,
    });

    return jsonObj;
  }

  function getNoUpcoming(item, secondary) {
    var jsonObj = extractBase(item, secondary);
    $.extend(jsonObj, {
      Title: localizer.NoUpcomingMeetings,
      Type: "primary",
      Status: statusArray.free,
    });
    return jsonObj;
  }

  function getEmptyData() {
    var jsonObj = {};
    $.extend(jsonObj, {
      Title: localizer.NoUpcomingMeetings,
      Type: "primary",
      Status: statusArray.free,
    });
    return jsonObj;
  }

  function getNotImplemented(item, secondary) {
    return {
      Title: item.Type + " NotImpl",
      Type: "primary",
      Status: statusArray.free,
    };
  }

  function getBusy(item, secondary) {
    var jsonObj = extractBase(item, secondary);
    $.extend(jsonObj, {
      Message: getEndsIn(item.HoursLeft, item.MinutesLeft),
      Status: statusArray.busy,
    });
    return jsonObj;
  }

  function getFreeAllDay(item, secondary) {
    var jsonObj = extractBase(item, secondary);
    $.extend(jsonObj, {
      Title: localizer.Available,
      Period: localizer.AvailableForTheRestOfTheDay,
      Status: statusArray.free,
    });
    return jsonObj;
  }

  function getBusyHidden(item, secondary) {
    var jsonObj = extractBase(item, secondary);
    $.extend(jsonObj, {
      Title: localizer.Unavailable,
      Owner: null,
      Message: getEndsIn(item.HoursLeft, item.HoursLeft),
      Status: statusArray.busy,
    });
    return jsonObj;
  }

  function getFutureHidden(item, secondary) {
    var jsonObj = extractBase(item, secondary);
    $.extend(jsonObj, {
      Title: localizer.Unavailable,
      Owner: null,
      Status: statusArray.busy,
    });
    return jsonObj;
  }

  function addNextHidden(item, secondary, jsonObj) {
    $.extend(jsonObj, {
      NextTitle: localizer.Unavailable,
      NextOwner: null,
    });
    return jsonObj;
  }

  function getFuture(item, secondary) {
    var jsonObj = extractBase(item, secondary);
    $.extend(jsonObj, {
      Status: statusArray.busy,
    });
    return jsonObj;
  }

  function getUnavailable(item, secondary) {
    var jsonObj = extractBase(item, secondary);
    $.extend(jsonObj, {
      Title: localizer.Unavailable,
      Owner: null,
      Status: statusArray.busy,
    });
    return jsonObj;
  }

  function getUnavailableNow(item, secondary) {
    var jsonObj = extractBase(item, secondary);
    $.extend(jsonObj, {
      Title: localizer.Unavailable,
      Owner: null,
      Status: statusArray.busy,
    });
    return jsonObj;
  }

  function getClosed(item, secondary) {
    var jsonObj = extractBase(item, secondary);
    $.extend(jsonObj, {
      Title: localizer.Closed,
      Status: statusArray.busy,
    });
    return jsonObj;
  }

  function getClosedAllDay(item, secondary) {
    var jsonObj = extractBase(item, secondary);
    $.extend(jsonObj, {
      Title: localizer.ClosedForTheRestOfTheDay,
      Status: statusArray.busy,
    });
    return jsonObj;
  }

  function getAvailableFor(hours, minutes) {
    return getTimeLeft(localizer.AvailableNext, hours, minutes);
  }

  function getEndsIn(hours, minutes) {
    return getTimeLeft(localizer.EndsIn, hours, minutes);
  }

  function getTimeLeft(prefix, hours, minutes) {
    var reply = prefix + " ";
    if (hours && hours > 0) {
      reply += hours + " " + localizer.HourShort + " ";
    }
    if (minutes && minutes > 0) {
      reply += minutes + " " + localizer.MinutesShort;
    }
    return reply;
  }

  function extractBase(item, secondary) {
    return {
      Id: item.MeetingId,
      RoomId: item.RoomId,
      Title: item.Title,
      Period: item.Period,
      OriginalPeriod: item.OriginalPeriod,
      Owner: item.Owner,
      Type: secondary ? "secondary" : "primary",
      HoursLeft: item.HoursLeft,
      MinutesLeft: item.MinutesLeft,
      MinutesPast: item.MinutesPast,
      MaxDurationMinutes: item.MaxDurationMinutes,
      /*additaional detail info*/
      SubType: item.Type,
      ReservationPeriod: item.ReservationPeriod,
      ReservationDayPeriod: item.ReservationDayPeriod,
      OwnerEmail: item.OwnerEmail,
      OwnerPhone: item.OwnerPhone,
      OwnerMobile: item.OwnerMobile,
      Contact: item.Contact,
      ContactEmail: item.ContactEmail,
      ContactPhone: item.ContactPhone,
      ContactMobile: item.ContactMobile,
      MeetingType: item.MeetingType,
      Participants: item.Participants,
      SequenceNumber: item.SequenceNumber,
      RemainingConfirmationSeconds: item.RemainingConfirmationSeconds,
      NeedsConfirmation: needsConfirmation(item),
      IsPrivate: item.IsPrivate,
      /*for reception*/
      Timestamp: item.Timestamp,
      MeetingPlace: item.MeetingPlace,
      DateTimeType: item.DateTimeType,
      /*next info*/
      HasNextInfo: item.HasNextInfo,
      NextType: item.NextType,
      NextTitle: item.NextTitle,
      NextPeriod: item.NextPeriod,
      NextOwner: item.NextOwner,
      /*new for booking*/
      IsLocked: item.IsLocked,
      /*Area interaction features*/
      InteractionFeatures: getInterActionFeatures(item),
      RoomDetail: getRoomDetails(item),
      ScheduledText: getNextMeetingScheduledToStart(item),
      Direction: item.Direction,
      HasDirection: item.Direction != null,
    };
  }

  function getNextMeetingScheduledToStart(item) {
    if (item.MinutesToStart != 0 && item.MinutesToStart <= interactivity.preparationTime /*&& isPrimaryFree(item)*/) {
      return localizer.StartsIn + " " + item.MinutesToStart + " " + localizer.MinutesShort;
    }
  }

  function getRoomDetails(item) {
    if (item && item.RoomDetail) {
      return item.RoomDetail;
    }
    return null;
  }

  function getInterActionFeatures(item) {
    if (item && item.InteractionFeatures) {
      return item.InteractionFeatures;
    }
    return null;
  }

  function needsConfirmation(item) {
    return item.NeedsConfirmation && interactivity.ConfirmationEnabled;
  }

  function extractContent(item, secondary) {
    //Free, FreeAllDay, Busy, Future, BusyHidden, FutureHidden, Unavailable, UnavailableNow, Closed, ClosedAllDay, NoUpcoming
    if (item && item.Type) {
      var returnData;
      switch (item.Type) {
        case "Free":
          returnData = getFree(item, secondary);
          break;
        case "NoUpcoming":
          returnData = getNoUpcoming(item, secondary);
          break;
        case "Busy":
          returnData = getBusy(item, secondary);
          break;
        case "Future":
          returnData = getFuture(item, secondary);
          break;
        case "FutureHidden":
          returnData = getFutureHidden(item, secondary);
          break;
        case "FreeAllDay":
          returnData = getFreeAllDay(item, secondary);
          break;
        case "Unavailable":
          returnData = getUnavailable(item, secondary);
          break;
        case "UnavailableNow":
          returnData = getUnavailableNow(item, secondary);
          break;
        case "Closed":
          returnData = getClosed(item, secondary);
          break;
        case "ClosedAllDay":
          returnData = getClosedAllDay(item, secondary);
          break;
        case "BusyHidden":
          returnData = getBusyHidden(item, secondary);
          break;
        default:
          returnData = getNotImplemented(item, secondary);
          break;
      }

      if (item.NextType) {
        switch (item.NextType) {
          case "FutureHidden":
            returnData = addNextHidden(item, secondary, returnData);
            break;
          case "Unavailable":
            returnData = addNextHidden(item, secondary, returnData);
            break;
          case "BusyHidden":
            returnData = addNextHidden(item, secondary, returnData);
            break;
          default:
            break;
        }
      }

      return returnData;
    } else {
      return getEmptyData();
    }
  }

  function isNullOrEmpty(value) {
    var result = true;
    if (value) {
      if (typeof value == "string") {
        if (value.length > 0) result = false;
      }
    }
    return result;
  }
  function getVisibility(screenVisibility) {
    var meetinglistButtonVisible = false;
    if (screenVisibility && screenVisibility.ShowMeetinglistButton) {
      meetinglistButtonVisible = true;
    }
    return { ShowMeetinglistButton: meetinglistButtonVisible };
  }

  function hasScreenDetails(item) {
    logThis("hasScreenDetails");
    logThis(item);
    if (item.Capacity || item.Description || item.Availability || item.TableSetups || item.Attributes) {
      return true;
    } else {
      return false;
    }
  }

  function hasScreenImage(item) {
    if (item.ImagePath) {
      return true;
    } else {
      return false;
    }
  }

  function hasItems(screenData) {
    return itemsDefined(screenData) && screenData.Items.length > 0;
  }

  function itemsDefined(screenData) {
    if (screenData.Items) {
      return true;
    } else {
      return false;
    }
  }
  function enablePrimaryBook(screenData) {
    var item = screenData.Items[0];
    return item.MaxDurationMinutes >= getMinimumBookTime() && isPrimaryFree(item) && interactivity.BookingEnabled;
  }

  function getMinimumBookTime() {
    if (screenSettings.interactivity.minimumBookTime) {
      return screenSettings.interactivity.minimumBookTime;
    } else {
      return interactivity.preparationTime;
    }
  }

  function pinCodeRequired(screenData) {
    var item = screenData.Items[0];
    if (item.InteractionFeatures) {
      return item.InteractionFeatures.PinCodeRequired;
    }
    return false;
  }

  function enablePrimaryEnd(screenData) {
    var item = screenData.Items[0];
    return isPrimaryBusy(item) && interactivity.ReschedulingEnabled && primaryMeetingIsStarted(screenData);
  }

  function primaryMeetingIsStarted(screenData) {
    return screenData.Items[0].MinutesPast >= 0;
  }

  function enablePrimaryReschedule(screenData) {
    var item = screenData.Items[0];
    return isPrimaryBusy(item) && interactivity.ReschedulingEnabled;
  }

  function getDateString(data) {
    if (data.ScreenInfo.TimeInfo.Date) {
      return data.ScreenInfo.TimeInfo.Date;
    }
    var timeUtility = new TimeUtility();
    var timeFormat = timeUtility.convertFromDotNet(data.ScreenInfo.TimeInfo.DateFormat);
    var currentTime = timeUtility.createTime(data.ScreenInfo.TimeInfo.SeedTime);

    return timeUtility.formatTime(timeFormat, currentTime, settings.localization);
  }

  function getTimeString(data) {
    if (data.ScreenInfo.TimeInfo.Time) {
      return data.ScreenInfo.TimeInfo.Time;
    }
    var timeUtility = new TimeUtility();
    var timeFormat = timeUtility.convertFromDotNet(data.ScreenInfo.TimeInfo.TimeFormat);
    var currentTime = timeUtility.createTime(data.ScreenInfo.TimeInfo.SeedTime);
    var result = timeUtility.formatTime(timeFormat, currentTime);
    return result;
  }

  function extractReceptionList(items, idx, max) {
    var jsonResult = new Array();
    for (var i = 0; i < items.length; i++) {
      if (i >= idx && i < idx + max) {
        var item = extractContent(items[i], 0);
        hasAnyDirection = item.HasDirection || hasAnyDirection;
        jsonResult.push(item);
      }
    }
    var hasAnyDirection = hasWayfinding(items);
    if (hasAnyDirection) {
      for (var i = 0; i < jsonResult.length; i++) {
        jsonResult[i].IsDirectionContext = hasAnyDirection;
      }
    }
    return jsonResult;
  }

  function hasWayfinding(items) {
    for (var i = 0; i < items.length; i++) {
      if (items[i].Direction != null && items[i].Direction != "" && items[i].Direction != "None") {
        return true;
      }
    }
    return false;
  }

  /*public methods*/

  this.extractSecurity = function (screenData) {
    if (screenData.ScreenInfo.ScreenSecurity) {
      return {
        PinCode: screenData.ScreenInfo.ScreenSecurity.PinCode,
        Salt: screenData.ScreenInfo.ScreenSecurity.Salt,
      };
    }
  };

  this.extractTimeStamp = function (screenData) {
    return screenData.ScreenInfo.TimeStamp;
  };
  this.extractScreenCommand = function (screenData) {
    return screenData.ScreenInfo.Command;
  };
  this.extractSecondaryContent = function (screenData) {
    var item = screenData.Items[1];
    return extractContent(item, 1);
  };

  this.extractTimeFormat = function (screenData) {
    var timeUtility = new TimeUtility();
    return timeUtility.convertFromDotNet(screenData.ScreenInfo.TimeInfo.TimeFormat);
  };

  this.extractStatusArray = function (screenData) {
    return statusArray;
  };

  this.extractDefectOptions = function (screenData) {
    var defectOptions = {
      defectItems: screenData.ScreenInfo.DefectOptions,
      hasDefectItems: screenData.ScreenInfo.DefectOptions ? screenData.ScreenInfo.DefectOptions.length > 0 : 0,
    };

    return defectOptions;
  };

  this.extractClockContent = function (screenData) {
    var item = screenData.ScreenInfo.TimeInfo.SeedTime;
    var myObject = {
      Year: item.Year,
      Month: item.Month,
      Day: item.Day,
      Hour: (item.Hour < 10 ? "0" : "") + item.Hour,
      Minute: (item.Minute < 10 ? "0" : "") + item.Minute,
      Second: item.Second,
      Millisecond: item.Millisecond,
      DateString: getDateString(screenData),
      TimeString: getTimeString(screenData),
    };

    return myObject;
  };
  this.extractItemsCount = function (screenData) {
    return screenData.Items.length;
  };

  this.extractScreenType = function (screenData) {
    return screenData.ScreenInfo.Type;
  };
  this.extractPrimaryContent = function (screenData, idx, max) {
    logThis("jsonResultbb");
    if (screenData.ScreenInfo.Type == "Reception" || screenData.ScreenInfo.Type == "Area") {
      return extractReceptionList(screenData.Items, idx, max);
    }
    var item = screenData.Items[0];
    return extractContent(item, 0);
  };

  this.extractList = function (screenData, idx, max) {
    if (screenData.Items.length > idx - 1) {
      return { List: extractReceptionList(screenData.Items, idx, max) };
    } else {
      return null;
    }
  };

  this.extractLastModifiedTime = function (screenData) {
    return screenData.ScreenInfo.LastModifiedTime;
  };

  this.extractRefreshContainer = function (screenData) {
    return screenData.ScreenInfo.RefreshContainer;
  };

  this.extractTrial = function (screenData) {
    return screenData.ScreenInfo.IsTrial;
  };

  this.extractCustomerName = function (screenData) {
    return screenData.ScreenInfo.CustomerName;
  };

  this.extractScreenInfoContent = function (screenData) {
    var item = screenData.ScreenInfo.ScreenDetail;
    var screenVisibility = screenData.ScreenInfo.ScreenVisibility;
    return getScreenInfoContent(item, screenVisibility);
  };
  this.extractScreenInfoContentForArea = function (item) {
    return getScreenInfoContent(item, null);
  };
  function getScreenInfoContent(item, screenVisibility) {
    var myObject = {
      Capacity: item.Capacity,
      Name: item.Name,
      Title: item.Title,
      Description: item.Description,
      RoomImage: item.ImagePath,
      Logo: item.Logo,
      HasLogo: !isNullOrEmpty(item.Logo),
      Availability: null,
      WeekSchema: null,
      TableSetups: null,
      Attributes: null,
      HasScreenInfo: hasScreenDetails(item) || hasScreenImage(item),
      HasScreenImage: hasScreenImage(item),
      HasScreenDetails: hasScreenDetails(item),
      ScreenVisibility: getVisibility(screenVisibility),
    };
    return myObject;
  }

  this.extractPrimaryInteractivity = function (screenData, localization) {
    var hasData = hasItems(screenData);
    var myObject = {
      Book: hasData && enablePrimaryBook(screenData),
      End: hasData && enablePrimaryEnd(screenData),
      Reschedule: hasData && enablePrimaryReschedule(screenData),
      NeedsConfirmation: needsConfirmation(screenData.Items[0]),
      PinCodeRequired: pinCodeRequired(screenData),
    };
    return myObject;
  };

  return this;
}

var jsonSturcture = {
  ScreenInfo: {
    RefreshContainer: false,
    IsTrial: false,
    LastModifiedTime: "25-01-2012 12:49:31",
    TimeInfo: {
      DateFormat: "d. MMMM yyyy",
      TimeFormat: "HH:mm",
      LanguageCode: "da-DK",
      SeedTime: {
        Year: 2012,
        Month: 1,
        Day: 25,
        Hour: 12,
        Minute: 50,
        Second: 33,
        Millisecond: 985,
      },
    },
  },
  Items: [
    {
      SequenceNumber: 1,
      MeetingId: null,
      MeetingPlace: null,
      Title: null,
      Period: "",
      ReservationPeriod: null,
      Owner: null,
      OwnerEmail: null,
      OwnerPhone: null,
      OwnerMobile: null,
      Contact: null,
      ContactEmail: null,
      ContactPhone: null,
      ContactMobile: null,
      MeetingType: null,
      Participants: null,
      Type: "FreeAllDay",
      AlternativeTitle: null,
      AlternativeOwner: null,
      DateTimeType: "Current",
      HoursLeft: null,
      MinutesLeft: null,
      AdditionalInfo: null,
      ShowRemainingTime: false,
      Timestamp: "634630890339820691",
      IsPrivate: false,
      HasNextInfo: false,
      NextType: null,
      NextTitle: null,
      NextPeriod: null,
      NextOwner: null,
      NeedsConfirmation: false,
      RemainingConfirmationSeconds: 0,
      MaxDurationMinutes: 670,
    },
    {
      SequenceNumber: 2,
      MeetingId: null,
      MeetingPlace: null,
      Title: null,
      Period: "",
      ReservationPeriod: null,
      Owner: null,
      OwnerPhone: null,
      OwnerMobile: null,
      Contact: null,
      ContactPhone: null,
      ContactMobile: null,
      MeetingType: null,
      Participants: null,
      Type: "NoUpcoming",
      AlternativeTitle: null,
      AlternativeOwner: null,
      DateTimeType: "Future",
      HoursLeft: null,
      MinutesLeft: null,
      AdditionalInfo: null,
      ShowRemainingTime: false,
      Timestamp: "634630890339820691",
      IsPrivate: false,
      HasNextInfo: false,
      NextType: null,
      NextTitle: null,
      NextPeriod: null,
      NextOwner: null,
      NeedsConfirmation: false,
      RemainingConfirmationSeconds: 0,
      MaxDurationMinutes: 0,
    },
  ],
};
