﻿function DemoScreen(options) {
  var settings = $.extend(
    {
      imagePath: null,
      primaryElement: null,
      screenType: "Room",
    },
    options
  );
  var imagePath = settings.imagePath;
  var screenType = settings.screenType;
  var screenHelper = new ScreenHelper();
  var stopPoll = false;
  var currentDemo = null;
  var screenInfo = {
    Type: "Room",
    CustomerName: "DemoData",
    RefreshContainer: false,
    IsTrial: false,
    LastModifiedTime: "09-02-2012 10:25:45",
    TimeInfo: {
      DateFormat: "d. MMMM yyyy",
      TimeFormat: "HH:mm",
      LanguageCode: "da-DK",
      SeedTime: { Year: 2012, Month: 2, Day: 9, Hour: 10, Minute: 25, Second: 49, Millisecond: 97 },
    },
    ScreenDetail: {
      Name: "Demo screen",
      Logo: "logo_animated.gif",
      ImagePath: "logo_animated.gif",
      Description: "hello",
      Capacity: "0",
    },
    ScreenVisibility: { ShowMeetinglistButton: true },
  };
  var receptionScreenInfo = {
    Type: "Reception",
    CustomerName: "DemoData",
    RefreshContainer: false,
    IsTrial: false,
    LastModifiedTime: "09-02-2012 10:25:45",
    TimeInfo: {
      DateFormat: "d. MMMM yyyy",
      TimeFormat: "HH:mm",
      LanguageCode: "da-DK",
      SeedTime: { Year: 2012, Month: 2, Day: 9, Hour: 10, Minute: 25, Second: 49, Millisecond: 97 },
    },
    ScreenDetail: {
      Title: "Welcome Demo",
      Name: "Demo screen",
      Logo: "logo_animated.gif",
      ImagePath: "logo_animated.gif",
      Description: "hello",
      Capacity: "0",
    },
  };
  var areaScreenInfo = {
    Type: "Area",
    CustomerName: "DemoData",
    RefreshContainer: false,
    IsTrial: false,
    LastModifiedTime: "09-02-2012 10:25:45",
    TimeInfo: {
      DateFormat: "d. MMMM yyyy",
      TimeFormat: "HH:mm",
      LanguageCode: "da-DK",
      SeedTime: { Year: 2012, Month: 2, Day: 9, Hour: 10, Minute: 25, Second: 49, Millisecond: 97 },
    },
    ScreenDetail: {
      Title: "Welcome Demo",
      Name: "Demo screen",
      Logo: "logo_animated.gif",
      ImagePath: "bg.jpg",
      Description: "hello",
      Capacity: "0",
    },
  };

  // ,,{"SequenceNumber":6,"MeetingId":null,"MeetingPlace":"Meeting room 4","Title":null,"Period":"7:19am - 9:00am","ReservationPeriod":null,"Owner":null,"OwnerPhone":null,"OwnerMobile":null,"Contact":null,"ContactPhone":null,"ContactMobile":null,"MeetingType":null,"Participants":null,"Type":"Free","AlternativeTitle":null,"AlternativeOwner":null,"DateTimeType":"Current","HoursLeft":"1","MinutesLeft":"41","AdditionalInfo":"Next meeting : IT monthly status - 9:00am - 10:00am","ShowRemainingTime":true,"Timestamp":"634708415954559422","IsPrivate":false,"HasNextInfo":true,"NextType":"Future","NextTitle":"IT monthly status","NextPeriod":"9:00am - 10:00am","NextOwner":"Mary Cambell","NeedsConfirmation":false,"RemainingConfirmationSeconds":0,"MaxDurationMinutes":101},{"SequenceNumber":7,"MeetingId":null,"MeetingPlace":"Meeting room 5","Title":null,"Period":"7:19am - 12:00pm","ReservationPeriod":null,"Owner":null,"OwnerPhone":null,"OwnerMobile":null,"Contact":null,"ContactPhone":null,"ContactMobile":null,"MeetingType":null,"Participants":null,"Type":"Free","AlternativeTitle":null,"AlternativeOwner":null,"DateTimeType":"Current","HoursLeft":"4","MinutesLeft":"41","AdditionalInfo":"Next meeting : Purchase dept. meeting - 12:00pm - 1:00pm","ShowRemainingTime":true,"Timestamp":"634708415954559422","IsPrivate":false,"HasNextInfo":true,"NextType":"Future","NextTitle":"Purchase dept. meeting","NextPeriod":"12:00pm - 1:00pm","NextOwner":"Martin Brown","NeedsConfirmation":false,"RemainingConfirmationSeconds":0,"MaxDurationMinutes":281}]};

  var demodataAreaList = {
    name: "Area list",
    id: "demodata_AreaList",
    data: {
      ScreenInfo: areaScreenInfo,
      Items: [
        {
          SequenceNumber: 1,
          IsLocked: false,
          MeetingId: null,
          MeetingPlace: "Auditorium A",
          Title: null,
          Period: "7:19am - 8:00am",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "Free",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "",
          MinutesLeft: "41",
          AdditionalInfo: "Next meeting : Sales training - 8:00am - 10:00am",
          ShowRemainingTime: true,
          Timestamp: "634708415954549421",
          IsPrivate: false,
          HasNextInfo: true,
          NextType: "Future",
          NextTitle: "Sales training",
          NextPeriod: "8:00am - 10:00am",
          NextOwner: "Jane Smith",
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 41,
        },
        {
          SequenceNumber: 2,
          IsLocked: false,
          MeetingId: null,
          MeetingPlace: "Meeting Room 1B",
          Title: null,
          Period: "7:19am - 10:00am",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "Free",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "2",
          MinutesLeft: "41",
          AdditionalInfo: "Next meeting : Executive meeting - 10:00am - 11:00am",
          ShowRemainingTime: true,
          Timestamp: "634708415954549421",
          IsPrivate: false,
          HasNextInfo: true,
          NextType: "Future",
          NextTitle: "Executive meeting",
          NextPeriod: "10:00am - 11:00am",
          NextOwner: "David Jones",
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 161,
        },
        {
          SequenceNumber: 3,
          IsLocked: false,
          MeetingId: null,
          MeetingPlace: "Meeting Room 6A",
          Title: null,
          Period: "7:19am - 11:00am",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "Free",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "3",
          MinutesLeft: "41",
          AdditionalInfo: "Next meeting : HR status meeting - 11:00am - 1:00pm",
          ShowRemainingTime: true,
          Timestamp: "634708415954549421",
          IsPrivate: false,
          HasNextInfo: true,
          NextType: "Future",
          NextTitle: "HR status meeting",
          NextPeriod: "11:00am - 1:00pm",
          NextOwner: "Peter Robinson",
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 221,
        },
        {
          SequenceNumber: 4,
          IsLocked: false,
          MeetingId: null,
          MeetingPlace: "Meeting Room 2A",
          Title: null,
          Period: "7:19am - 9:00am",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "Free",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "1",
          MinutesLeft: "41",
          AdditionalInfo: "Next meeting : Sales forecast Q1 - 9:00am - 10:00am",
          ShowRemainingTime: true,
          Timestamp: "634708415954549421",
          IsPrivate: false,
          HasNextInfo: true,
          NextType: "Future",
          NextTitle: "Sales forecast Q1",
          NextPeriod: "9:00am - 10:00am",
          NextOwner: "Dan Fletcher",
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 101,
        },
        {
          SequenceNumber: 5,
          IsLocked: false,
          MeetingId: null,
          MeetingPlace: "Meeting Room 4B",
          Title: null,
          Period: "7:19am - 11:00am",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "Free",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "3",
          MinutesLeft: "41",
          AdditionalInfo: "Next meeting : Marketing advertising campaign - 11:00am - 1:00pm",
          ShowRemainingTime: true,
          Timestamp: "634708415954559422",
          IsPrivate: false,
          HasNextInfo: true,
          NextType: "Future",
          NextTitle: "Marketing advertising campaign",
          NextPeriod: "11:00am - 1:00pm",
          NextOwner: "Marleen Benson",
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 221,
        },
      ],
    },
  };

  var demodataAreaListWithBusy = {
    name: "Area busy list",
    id: "demodata_AreaListWithBusy",
    data: {
      ScreenInfo: areaScreenInfo,
      Items: [
        {
          SequenceNumber: 1,
          IsLocked: false,
          MeetingId: "a722783f-9d8e-4294-9551-daf0d6b20ab1",
          MeetingPlace: "Auditorium A",
          Title: "Meeting with proNestor on pronestor Display",
          Period: "4:06pm - 5:15pm",
          ReservationPeriod: "4:06 PM - 5:15 PM",
          Owner: "David Jones",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Busy",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "1",
          MinutesLeft: "9",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: true,
          RemainingConfirmationSeconds: 899,
          MaxDurationMinutes: 99,
        },
        {
          SequenceNumber: 2,
          IsLocked: false,
          MeetingId: null,
          MeetingPlace: "Meeting Room 1B",
          Title: null,
          Period: "7:19am - 10:00am",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "Free",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "2",
          MinutesLeft: "41",
          AdditionalInfo: "Next meeting : Executive meeting - 10:00am - 11:00am",
          ShowRemainingTime: true,
          Timestamp: "634708415954549421",
          IsPrivate: false,
          HasNextInfo: true,
          NextType: "Future",
          NextTitle: "Executive meeting",
          NextPeriod: "10:00am - 11:00am",
          NextOwner: "David Jones",
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 161,
        },
        {
          SequenceNumber: 3,
          IsLocked: false,
          MeetingId: null,
          MeetingPlace: "Meeting Room 6A",
          Title: null,
          Period: "7:19am - 11:00am",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "Free",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "3",
          MinutesLeft: "41",
          AdditionalInfo: "Next meeting : HR status meeting - 11:00am - 1:00pm",
          ShowRemainingTime: true,
          Timestamp: "634708415954549421",
          IsPrivate: false,
          HasNextInfo: true,
          NextType: "Future",
          NextTitle: "HR status meeting",
          NextPeriod: "11:00am - 1:00pm",
          NextOwner: "Peter Robinson",
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 221,
        },
        {
          SequenceNumber: 4,
          IsLocked: false,
          MeetingId: null,
          MeetingPlace: "Meeting Room 2A",
          Title: null,
          Period: "7:19am - 9:00am",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "Free",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "1",
          MinutesLeft: "41",
          AdditionalInfo: "Next meeting : Sales forecast Q1 - 9:00am - 10:00am",
          ShowRemainingTime: true,
          Timestamp: "634708415954549421",
          IsPrivate: false,
          HasNextInfo: true,
          NextType: "Future",
          NextTitle: "Sales forecast Q1",
          NextPeriod: "9:00am - 10:00am",
          NextOwner: "Dan Fletcher",
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 101,
        },
        {
          SequenceNumber: 5,
          IsLocked: false,
          MeetingId: null,
          MeetingPlace: "Meeting Room 4B",
          Title: null,
          Period: "7:19am - 11:00am",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "Free",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "3",
          MinutesLeft: "41",
          AdditionalInfo: "Next meeting : Marketing advertising campaign - 11:00am - 1:00pm",
          ShowRemainingTime: true,
          Timestamp: "634708415954559422",
          IsPrivate: false,
          HasNextInfo: true,
          NextType: "Future",
          NextTitle: "Marketing advertising campaign",
          NextPeriod: "11:00am - 1:00pm",
          NextOwner: "Marleen Benson",
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 221,
        },
      ],
    },
  };

  var demodataAreaListLong = {
    name: "Area list Long",
    id: "demodata_AreaListLong ",
    data: {
      ScreenInfo: areaScreenInfo,
      Items: [
        {
          SequenceNumber: 1,
          MeetingId: null,
          MeetingPlace: "Auditorium A",
          Title: null,
          Period: "7:19am - 8:00am",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "Free",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "",
          MinutesLeft: "41",
          AdditionalInfo: "Next meeting : Sales training - 8:00am - 10:00am",
          ShowRemainingTime: true,
          Timestamp: "634708415954549421",
          IsPrivate: false,
          HasNextInfo: true,
          NextType: "Future",
          NextTitle: "Sales training",
          NextPeriod: "8:00am - 10:00am",
          NextOwner: "Jane Smith",
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 41,
        },
        {
          SequenceNumber: 2,
          MeetingId: null,
          MeetingPlace: "Meeting Room 1B",
          Title: null,
          Period: "7:19am - 10:00am",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "Free",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "2",
          MinutesLeft: "41",
          AdditionalInfo: "Next meeting : Executive meeting - 10:00am - 11:00am",
          ShowRemainingTime: true,
          Timestamp: "634708415954549421",
          IsPrivate: false,
          HasNextInfo: true,
          NextType: "Future",
          NextTitle: "Executive meeting",
          NextPeriod: "10:00am - 11:00am",
          NextOwner: "David Jones",
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 161,
        },
        {
          SequenceNumber: 3,
          MeetingId: null,
          MeetingPlace: "Meeting Room 6A",
          Title: null,
          Period: "7:19am - 11:00am",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "Free",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "3",
          MinutesLeft: "41",
          AdditionalInfo: "Next meeting : HR status meeting - 11:00am - 1:00pm",
          ShowRemainingTime: true,
          Timestamp: "634708415954549421",
          IsPrivate: false,
          HasNextInfo: true,
          NextType: "Future",
          NextTitle: "HR status meeting",
          NextPeriod: "11:00am - 1:00pm",
          NextOwner: "Peter Robinson",
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 221,
        },
        {
          SequenceNumber: 4,
          MeetingId: null,
          MeetingPlace: "Meeting Room 2A",
          Title: null,
          Period: "7:19am - 9:00am",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "Free",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "1",
          MinutesLeft: "41",
          AdditionalInfo: "Next meeting : Sales forecast Q1 - 9:00am - 10:00am",
          ShowRemainingTime: true,
          Timestamp: "634708415954549421",
          IsPrivate: false,
          HasNextInfo: true,
          NextType: "Future",
          NextTitle: "Sales forecast Q1",
          NextPeriod: "9:00am - 10:00am",
          NextOwner: "Dan Fletcher",
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 101,
        },
        {
          SequenceNumber: 5,
          MeetingId: null,
          MeetingPlace: "Meeting Room 4B",
          Title: null,
          Period: "7:19am - 11:00am",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "Free",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "3",
          MinutesLeft: "41",
          AdditionalInfo: "Next meeting : Marketing advertising campaign - 11:00am - 1:00pm",
          ShowRemainingTime: true,
          Timestamp: "634708415954559422",
          IsPrivate: false,
          HasNextInfo: true,
          NextType: "Future",
          NextTitle: "Marketing advertising campaign",
          NextPeriod: "11:00am - 1:00pm",
          NextOwner: "Marleen Benson",
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 221,
        },
        {
          SequenceNumber: 11,
          MeetingId: null,
          MeetingPlace: "Meeting Room 7A",
          Title: null,
          Period: "7:19am - 8:00am",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "Free",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "",
          MinutesLeft: "41",
          AdditionalInfo: "Next meeting : Sales training - 8:00am - 10:00am",
          ShowRemainingTime: true,
          Timestamp: "634708415954549421",
          IsPrivate: false,
          HasNextInfo: true,
          NextType: "Future",
          NextTitle: "Sales training",
          NextPeriod: "8:00am - 10:00am",
          NextOwner: "Jane Smith",
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 41,
        },
        {
          SequenceNumber: 12,
          MeetingId: null,
          MeetingPlace: "Meeting Room 7B",
          Title: null,
          Period: "7:19am - 10:00am",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "Free",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "2",
          MinutesLeft: "41",
          AdditionalInfo: "Next meeting : Executive meeting - 10:00am - 11:00am",
          ShowRemainingTime: true,
          Timestamp: "634708415954549421",
          IsPrivate: false,
          HasNextInfo: true,
          NextType: "Future",
          NextTitle: "Executive meeting",
          NextPeriod: "10:00am - 11:00am",
          NextOwner: "David Jones",
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 161,
        },
        {
          SequenceNumber: 13,
          MeetingId: null,
          MeetingPlace: "Meeting Room 2B",
          Title: null,
          Period: "7:19am - 11:00am",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "Free",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "3",
          MinutesLeft: "41",
          AdditionalInfo: "Next meeting : HR status meeting - 11:00am - 1:00pm",
          ShowRemainingTime: true,
          Timestamp: "634708415954549421",
          IsPrivate: false,
          HasNextInfo: true,
          NextType: "Future",
          NextTitle: "HR status meeting",
          NextPeriod: "11:00am - 1:00pm",
          NextOwner: "Peter Robinson",
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 221,
        },
        {
          SequenceNumber: 14,
          MeetingId: null,
          MeetingPlace: "Meeting Room 3B",
          Title: null,
          Period: "7:19am - 9:00am",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "Free",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "1",
          MinutesLeft: "41",
          AdditionalInfo: "Next meeting : Sales forecast Q1 - 9:00am - 10:00am",
          ShowRemainingTime: true,
          Timestamp: "634708415954549421",
          IsPrivate: false,
          HasNextInfo: true,
          NextType: "Future",
          NextTitle: "Sales forecast Q1",
          NextPeriod: "9:00am - 10:00am",
          NextOwner: "Dan Fletcher",
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 101,
        },
        {
          SequenceNumber: 15,
          MeetingId: null,
          MeetingPlace: "Meeting Room 9A",
          Title: null,
          Period: "7:19am - 11:00am",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "Free",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "3",
          MinutesLeft: "41",
          AdditionalInfo: "Next meeting : Marketing advertising campaign - 11:00am - 1:00pm",
          ShowRemainingTime: true,
          Timestamp: "634708415954559422",
          IsPrivate: false,
          HasNextInfo: true,
          NextType: "Future",
          NextTitle: "Marketing advertising campaign",
          NextPeriod: "11:00am - 1:00pm",
          NextOwner: "Marleen Benson",
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 221,
        },
      ],
    },
  };
  /* var demodataAreaListWithBusy = {
        name: 'Area busy list',
        id: 'demodata_AreaListWithBusy',
        data: { "ScreenInfo": areaScreenInfo, "Items": [
            { "SequenceNumber": 1, "MeetingId": null, "MeetingPlace": "Auditorium2", "Title": null, "Period": "7:19am - 8:00am", "ReservationPeriod": null, "Owner": null, "OwnerPhone": null, "OwnerMobile": null, "Contact": null, "ContactPhone": null, "ContactMobile": null, "MeetingType": null, "Participants": null, "Type": "Free", "AlternativeTitle": null, "AlternativeOwner": null, "DateTimeType": "Current", "HoursLeft": "", "MinutesLeft": "41", "AdditionalInfo": "Next meeting : Sales training - 8:00am - 10:00am", "ShowRemainingTime": true, "Timestamp": "634708415954549421", "IsPrivate": false, "HasNextInfo": true, "NextType": "Future", "NextTitle": "Sales training", "NextPeriod": "8:00am - 10:00am", "NextOwner": "Jane Smith", "NeedsConfirmation": false, "RemainingConfirmationSeconds": 0, "MaxDurationMinutes": 41 },
            { "SequenceNumber": 2, "MeetingId": null, "MeetingPlace": "Board room", "Title": null, "Period": "7:19am - 10:00am", "ReservationPeriod": null, "Owner": null, "OwnerPhone": null, "OwnerMobile": null, "Contact": null, "ContactPhone": null, "ContactMobile": null, "MeetingType": null, "Participants": null, "Type": "Free", "AlternativeTitle": null, "AlternativeOwner": null, "DateTimeType": "Current", "HoursLeft": "2", "MinutesLeft": "41", "AdditionalInfo": "Next meeting : Executive meeting - 10:00am - 11:00am", "ShowRemainingTime": true, "Timestamp": "634708415954549421", "IsPrivate": false, "HasNextInfo": true, "NextType": "Future", "NextTitle": "Executive meeting", "NextPeriod": "10:00am - 11:00am", "NextOwner": "David Jones", "NeedsConfirmation": false, "RemainingConfirmationSeconds": 0, "MaxDurationMinutes": 161 },
            { "SequenceNumber": 3, "MeetingId": null, "MeetingPlace": "Meeting room 1", "Title": null, "Period": "7:19am - 11:00am", "ReservationPeriod": null, "Owner": null, "OwnerPhone": null, "OwnerMobile": null, "Contact": null, "ContactPhone": null, "ContactMobile": null, "MeetingType": null, "Participants": null, "Type": "Free", "AlternativeTitle": null, "AlternativeOwner": null, "DateTimeType": "Current", "HoursLeft": "3", "MinutesLeft": "41", "AdditionalInfo": "Next meeting : HR status meeting - 11:00am - 1:00pm", "ShowRemainingTime": true, "Timestamp": "634708415954549421", "IsPrivate": false, "HasNextInfo": true, "NextType": "Future", "NextTitle": "HR status meeting", "NextPeriod": "11:00am - 1:00pm", "NextOwner": "Peter Robinson", "NeedsConfirmation": false, "RemainingConfirmationSeconds": 0, "MaxDurationMinutes": 221 },
            { "SequenceNumber": 4, "MeetingId": null, "MeetingPlace": "Meeting room 2", "Title": null, "Period": "7:19am - 9:00am", "ReservationPeriod": null, "Owner": null, "OwnerPhone": null, "OwnerMobile": null, "Contact": null, "ContactPhone": null, "ContactMobile": null, "MeetingType": null, "Participants": null, "Type": "Free", "AlternativeTitle": null, "AlternativeOwner": null, "DateTimeType": "Current", "HoursLeft": "1", "MinutesLeft": "41", "AdditionalInfo": "Next meeting : Sales forecast Q1 - 9:00am - 10:00am", "ShowRemainingTime": true, "Timestamp": "634708415954549421", "IsPrivate": false, "HasNextInfo": true, "NextType": "Future", "NextTitle": "Sales forecast Q1", "NextPeriod": "9:00am - 10:00am", "NextOwner": "Dan Fletcher", "NeedsConfirmation": false, "RemainingConfirmationSeconds": 0, "MaxDurationMinutes": 101 },
            { "SequenceNumber": 5, "MeetingId": null, "MeetingPlace": "Meeting room 3", "Title": null, "Period": "7:19am - 11:00am", "ReservationPeriod": null, "Owner": null, "OwnerPhone": null, "OwnerMobile": null, "Contact": null, "ContactPhone": null, "ContactMobile": null, "MeetingType": null, "Participants": null, "Type": "Free", "AlternativeTitle": null, "AlternativeOwner": null, "DateTimeType": "Current", "HoursLeft": "3", "MinutesLeft": "41", "AdditionalInfo": "Next meeting : Marketing advertising campaign - 11:00am - 1:00pm", "ShowRemainingTime": true, "Timestamp": "634708415954559422", "IsPrivate": false, "HasNextInfo": true, "NextType": "Future", "NextTitle": "Marketing advertising campaign", "NextPeriod": "11:00am - 1:00pm", "NextOwner": "Marleen Benson", "NeedsConfirmation": false, "RemainingConfirmationSeconds": 0, "MaxDurationMinutes": 221 }
        ]
        }
    };*/

  var demodataRandom = {
    name: "Random",
    id: "demodata_demodataRandom",
  };

  var demodataReceptionList = {
    name: "Reception list",
    id: "demodata_ReceptionList",
    data: {
      ScreenInfo: receptionScreenInfo,
      Items: [
        {
          SequenceNumber: 1,
          IsLocked: false,
          MeetingId: "a722783f-9d8e-4294-9551-daf0d6b20ab1",
          MeetingPlace: "Auditorium A",
          Title: "New Market Trends",
          Period: "6:00am - 8:15am",
          ReservationPeriod: "6:00 AM - 8:15 AM",
          ReservationDayPeriod: "6:00 AM - 8:15 AM",
          Owner: "David Raven",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Busy",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "1",
          MinutesLeft: "9",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: true,
          RemainingConfirmationSeconds: 899,
          MaxDurationMinutes: 99,
        },
        {
          SequenceNumber: 2,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-4567-360d90f61bec",
          MeetingPlace: "Auditorium A",
          Title: "TV campaign screening",
          Period: "6:45am - 11:45am",
          ReservationPeriod: "6:45 AM - 11:45 AM",
          ReservationDayPeriod: "6:45 AM - 11:45 AM",
          Owner: "Elisabeth Johnson",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 3,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 1B",
          Title: "HR Department Meeting",
          Period: "7:00am - 8:00am",
          ReservationPeriod: "7:00 AM - 8:00 AM",
          ReservationDayPeriod: "7:00 AM - 8:00 AM",
          Owner: "Martin Smith",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 4,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-6789-360d90f61bec",
          MeetingPlace: "Meeting Room 6A",
          Title: "Quality Control Review",
          Period: "8:00am - 10:00am",
          ReservationPeriod: "8:00 AM - 10:00 AM",
          ReservationDayPeriod: "8:00 AM - 10:00 AM",
          Owner: "Howard Peterson",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 5,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 2A",
          Title: "Production Planning Q2",
          Period: "8:00am - 9:30am",
          ReservationPeriod: "8:00 AM - 9:30 AM",
          ReservationDayPeriod: "8:00 AM - 9:30 AM",
          Owner: "Bill Sanderson",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 6,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4567-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 4B",
          Title: "Meeting with Company XYZ",
          Period: "12:00pm - 2:00pm",
          ReservationPeriod: "12:00 PM - 2:00 PM",
          ReservationDayPeriod: "12:00 PM - 2:00 PM",
          Owner: "Helena Cavey",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 7,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-5678-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 7A",
          Title: "Sales Forecast",
          Period: "12:30pm - 4:00pm",
          ReservationPeriod: "12:30 PM - 4:00 PM",
          ReservationDayPeriod: "12:30 PM - 4:00 PM",
          Owner: "Allan Ferry",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 8,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-2345-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 10B",
          Title: "Confidential",
          Period: "12:30pm - 4:00pm",
          ReservationPeriod: "12:30 PM - 4:00 PM",
          ReservationDayPeriod: "12:30 PM - 4:00 PM",
          Owner: "Jerry Kim",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 9,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-6789-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 8B",
          Title: "Business plan – Region North",
          Period: "1:00pm - 3:00pm",
          ReservationPeriod: "1:00 PM - 3:00 PM",
          ReservationDayPeriod: "1:00 PM - 3:00 PM",
          Owner: "Nancy Warren",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 10,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-1234-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 7B",
          Title: "Management Review",
          Period: "1:00pm - 3:00pm",
          ReservationPeriod: "1:00 PM - 3:00 PM",
          ReservationDayPeriod: "1:00 PM - 3:00 PM",
          Owner: "Enrico Marco",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 11,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-2347-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 2B",
          Title: "IT Dept. Meeting",
          Period: "4:00pm - 5:00pm",
          ReservationPeriod: "4:00 PM - 5:00 PM",
          ReservationDayPeriod: "4:00 PM - 5:00 PM",
          Owner: "Ellen Terrence",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 12,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-7245-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 3B",
          Title: "Design Review 2013",
          Period: "4:00pm - 6:00pm",
          ReservationPeriod: "4:00 PM - 6:00 PM",
          ReservationDayPeriod: "4:00 PM - 6:00 PM",
          Owner: "William Hall",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 13,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-7532-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 9A",
          Title: "Marketing Planning",
          Period: "8:00pm - 10:00pm",
          ReservationPeriod: "8:00 PM - 10:00 PM",
          ReservationDayPeriod: "8:00 PM - 10:00 PM",
          Owner: "Chan Wue",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
      ],
    },
  };
  var demodataReceptionListShort = {
    name: "Reception list short",
    id: "demodata_ReceptionListShort",
    data: {
      ScreenInfo: receptionScreenInfo,
      Items: [
        {
          SequenceNumber: 1,
          IsLocked: false,
          MeetingId: "a722783f-9d8e-4294-9551-daf0d6b20ab1",
          MeetingPlace: "Auditorium A",
          Title: "New Market Trends",
          Period: "6:00am - 8:15am",
          ReservationPeriod: "6:00 AM - 8:15 AM",
          ReservationDayPeriod: "6:00 AM - 8:15 AM",
          Owner: "David Raven",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Busy",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "1",
          MinutesLeft: "9",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: true,
          RemainingConfirmationSeconds: 899,
          MaxDurationMinutes: 99,
        },
        {
          SequenceNumber: 2,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-4567-360d90f61bec",
          MeetingPlace: "Auditorium A",
          Title: "TV campaign screening",
          Period: "6:45am - 11:45am",
          ReservationPeriod: "6:45 AM - 11:45 AM",
          ReservationDayPeriod: "6:45 AM - 11:45 AM",
          Owner: "Elisabeth Johnson",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 3,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 1B",
          Title: "HR Department Meeting",
          Period: "7:00am - 8:00am",
          ReservationPeriod: "7:00 AM - 8:00 AM",
          ReservationDayPeriod: "7:00 AM - 8:00 AM",
          Owner: "Martin Smith",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 4,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-6789-360d90f61bec",
          MeetingPlace: "Meeting Room 6A",
          Title: "Quality Control Review",
          Period: "8:00am - 10:00am",
          ReservationPeriod: "8:00 AM - 10:00 AM",
          ReservationDayPeriod: "8:00 AM - 10:00 AM",
          Owner: "Howard Peterson",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
      ],
    },
  };

  var demodataReceptionListShortLongText = {
    name: "Long Text Demo",
    id: "demodata_ReceptionListShortLongText",
    data: {
      ScreenInfo: receptionScreenInfo,
      Items: [
        {
          SequenceNumber: 1,
          IsLocked: false,
          MeetingId: "a722783f-9d8e-4294-9551-daf0d6b20ab1",
          MeetingPlace: "Auditorium A",
          Title: "New Market Trends, Production Planning Q2, Confidential, IT Dept. Meeting",
          Period: "6:00am - 8:15am",
          ReservationPeriod: "6:00 AM - 8:15 AM",
          ReservationDayPeriod: "6:00 AM - 8:15 AM",
          Owner: "David Raven Martin Smith Howard Peterson Bill Sanderson",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Busy",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "1",
          MinutesLeft: "9",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: true,
          RemainingConfirmationSeconds: 899,
          MaxDurationMinutes: 99,
        },
        {
          SequenceNumber: 2,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-4567-360d90f61bec",
          MeetingPlace: "Auditorium A",
          Title: "TV campaign screening, Meeting with Company XYZ, Business plan – Region North, Design Review 2013",
          Period: "6:45am - 11:45am",
          ReservationPeriod: "6:45 AM - 11:45 AM",
          ReservationDayPeriod: "6:45 AM - 11:45 AM",
          Owner: "Elisabeth Johnson Helena Cavey Nancy Warren Ellen Terrence",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 3,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 1B",
          Title: "HR Department Meeting, Sales Forecast, Management Review, Marketing Planning",
          Period: "7:00am - 8:00am",
          ReservationPeriod: "7:00 AM - 8:00 AM",
          ReservationDayPeriod: "7:00 AM - 8:00 AM",
          Owner: "Martin Smith",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 4,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-6789-360d90f61bec",
          MeetingPlace: "Meeting Room 6A",
          Title: "Quality Control Review",
          Period: "8:00am - 10:00am",
          ReservationPeriod: "8:00 AM - 10:00 AM",
          ReservationDayPeriod: "8:00 AM - 10:00 AM",
          Owner: "Howard Peterson",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
      ],
    },
  };

  var demodataReceptionListShort2 = {
    name: "Reception list short",
    id: "demodata_ReceptionListShort",
    data: {
      ScreenInfo: receptionScreenInfo,
      Items: [
        {
          SequenceNumber: 1,
          IsLocked: false,
          MeetingId: "a722783f-9d8e-4294-9551-daf0d6b20ab1",
          MeetingPlace: "Auditorium A",
          Title: "New Market Trends",
          Period: "6:00am - 8:15am",
          ReservationPeriod: "6:00 AM - 8:15 AM",
          ReservationDayPeriod: "6:00 AM - 8:15 AM",
          Owner: "David Raven",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Busy",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "1",
          MinutesLeft: "9",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: true,
          RemainingConfirmationSeconds: 899,
          MaxDurationMinutes: 99,
        },
        {
          SequenceNumber: 2,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-4567-360d90f61bec",
          MeetingPlace: "Auditorium A",
          Title: "TV campaign screening",
          Period: "6:45am - 11:45am",
          ReservationPeriod: "6:45 AM - 11:45 AM",
          ReservationDayPeriod: "6:45 AM - 11:45 AM",
          Owner: "Elisabeth Johnson",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 3,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 1B",
          Title: "HR Department Meeting",
          Period: "7:00am - 8:00am",
          ReservationPeriod: "7:00 AM - 8:00 AM",
          ReservationDayPeriod: "7:00 AM - 8:00 AM",
          Owner: "Martin Smith",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 4,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-6789-360d90f61bec",
          MeetingPlace: "Meeting Room 6A",
          Title: "Quality Control Review",
          Period: "8:00am - 10:00am",
          ReservationPeriod: "8:00 AM - 10:00 AM",
          ReservationDayPeriod: "8:00 AM - 10:00 AM",
          Owner: "Howard Peterson",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 5,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 2A",
          Title: "Production Planning Q2",
          Period: "8:00am - 9:30am",
          ReservationPeriod: "8:00 AM - 9:30 AM",
          ReservationDayPeriod: "8:00 AM - 9:30 AM",
          Owner: "Bill Sanderson",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
      ],
    },
  };

  var demodataReceptionListShort3 = {
    name: "Reception list short",
    id: "demodata_ReceptionListShort",
    data: {
      ScreenInfo: receptionScreenInfo,
      Items: [
        {
          SequenceNumber: 1,
          IsLocked: false,
          MeetingId: "a722783f-9d8e-4294-9551-daf0d6b20ab1",
          MeetingPlace: "Auditorium A",
          Title: "New Market Trends",
          Period: "6:00am - 8:15am",
          ReservationPeriod: "6:00 AM - 8:15 AM",
          ReservationDayPeriod: "6:00 AM - 8:15 AM",
          Owner: "David Raven",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Busy",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "1",
          MinutesLeft: "9",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: true,
          RemainingConfirmationSeconds: 899,
          MaxDurationMinutes: 99,
        },
        {
          SequenceNumber: 2,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-4567-360d90f61bec",
          MeetingPlace: "Auditorium A",
          Title: "TV campaign screening",
          Period: "6:45am - 11:45am",
          ReservationPeriod: "6:45 AM - 11:45 AM",
          ReservationDayPeriod: "6:45 AM - 11:45 AM",
          Owner: "Elisabeth Johnson",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 3,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 1B",
          Title: "HR Department Meeting",
          Period: "7:00am - 8:00am",
          ReservationPeriod: "7:00 AM - 8:00 AM",
          ReservationDayPeriod: "7:00 AM - 8:00 AM",
          Owner: "Martin Smith",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 4,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-6789-360d90f61bec",
          MeetingPlace: "Meeting Room 6A",
          Title: "Quality Control Review",
          Period: "8:00am - 10:00am",
          ReservationPeriod: "8:00 AM - 10:00 AM",
          ReservationDayPeriod: "8:00 AM - 10:00 AM",
          Owner: "Howard Peterson",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 5,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 2A",
          Title: "Production Planning Q2",
          Period: "8:00am - 9:30am",
          ReservationPeriod: "8:00 AM - 9:30 AM",
          ReservationDayPeriod: "8:00 AM - 9:30 AM",
          Owner: "Bill Sanderson",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 6,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4567-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 4B",
          Title: "Meeting with Company XYZ",
          Period: "12:00pm - 2:00pm",
          ReservationPeriod: "12:00 PM - 2:00 PM",
          ReservationDayPeriod: "12:00 PM - 2:00 PM",
          Owner: "Helena Cavey",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
      ],
    },
  };
  var demodataReceptionListShort4 = {
    name: "Reception list short",
    id: "demodata_ReceptionListShort",
    data: {
      ScreenInfo: receptionScreenInfo,
      Items: [
        {
          SequenceNumber: 1,
          IsLocked: false,
          MeetingId: "a722783f-9d8e-4294-9551-daf0d6b20ab1",
          MeetingPlace: "Auditorium A",
          Title: "New Market Trends",
          Period: "6:00am - 8:15am",
          ReservationPeriod: "6:00 AM - 8:15 AM",
          ReservationDayPeriod: "6:00 AM - 8:15 AM",
          Owner: "David Raven",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Busy",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "1",
          MinutesLeft: "9",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: true,
          RemainingConfirmationSeconds: 899,
          MaxDurationMinutes: 99,
        },
        {
          SequenceNumber: 2,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-4567-360d90f61bec",
          MeetingPlace: "Auditorium A",
          Title: "TV campaign screening",
          Period: "6:45am - 11:45am",
          ReservationPeriod: "6:45 AM - 11:45 AM",
          ReservationDayPeriod: "6:45 AM - 11:45 AM",
          Owner: "Elisabeth Johnson",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 3,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 1B",
          Title: "HR Department Meeting",
          Period: "7:00am - 8:00am",
          ReservationPeriod: "7:00 AM - 8:00 AM",
          ReservationDayPeriod: "7:00 AM - 8:00 AM",
          Owner: "Martin Smith",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 4,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-6789-360d90f61bec",
          MeetingPlace: "Meeting Room 6A",
          Title: "Quality Control Review",
          Period: "8:00am - 10:00am",
          ReservationPeriod: "8:00 AM - 10:00 AM",
          ReservationDayPeriod: "8:00 AM - 10:00 AM",
          Owner: "Howard Peterson",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 5,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 2A",
          Title: "Production Planning Q2",
          Period: "8:00am - 9:30am",
          ReservationPeriod: "8:00 AM - 9:30 AM",
          ReservationDayPeriod: "8:00 AM - 9:30 AM",
          Owner: "Bill Sanderson",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 6,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4567-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 4B",
          Title: "Meeting with Company XYZ",
          Period: "12:00pm - 2:00pm",
          ReservationPeriod: "12:00 PM - 2:00 PM",
          ReservationDayPeriod: "12:00 PM - 2:00 PM",
          Owner: "Helena Cavey",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 7,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-5678-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 7A",
          Title: "Sales Forecast",
          Period: "12:30pm - 4:00pm",
          ReservationPeriod: "12:30 PM - 4:00 PM",
          ReservationDayPeriod: "12:30 PM - 4:00 PM",
          Owner: "Allan Ferry",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
        {
          SequenceNumber: 8,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-2345-2345-360d90f61bec",
          MeetingPlace: "Meeting Room 10B",
          Title: "Confidential",
          Period: "12:30pm - 4:00pm",
          ReservationPeriod: "12:30 PM - 4:00 PM",
          ReservationDayPeriod: "12:30 PM - 4:00 PM",
          Owner: "Jerry Kim",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
      ],
    },
  };

  var demodataReceptionListEmpty = {
    name: "Reception list empty",
    id: "demodata_ReceptionListEmpty",
    data: { ScreenInfo: receptionScreenInfo, Items: [] },
  };
  var demodataScenario = {
    name: "Paging To None Paging",
    id: "demodata_demodataPagingToNonePaging",
    type: "scenario",
    idx: 0,
    cycle: false,
    data: { ScreenInfo: receptionScreenInfo, Items: [] },
    steps: [demodataReceptionList, demodataReceptionListShort],
  };

  var demodataScenarioCycle = {
    name: "Data cycle",
    id: "demodata_demodataCycle",
    type: "scenario",
    idx: 0,
    cycle: true,
    data: { ScreenInfo: receptionScreenInfo, Items: [] },
    steps: [
      demodataReceptionListShort,
      demodataReceptionListShort2,
      demodataReceptionListShort3,
      demodataReceptionListShort4,
    ],
  };

  var demodataFreeAllDay = {
    name: "Free All Day",
    id: "demodata_FreeAllDay",
    data: {
      ScreenInfo: screenInfo,
      Items: [
        {
          SequenceNumber: 1,
          IsLocked: false,
          MeetingId: null,
          MeetingPlace: null,
          Title: null,
          Period: "",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "FreeAllDay",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: null,
          MinutesLeft: null,
          AdditionalInfo: null,
          ShowRemainingTime: false,
          Timestamp: "634643763490942971",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 815,
        },
        {
          SequenceNumber: 2,
          IsLocked: false,
          MeetingId: null,
          MeetingPlace: null,
          Title: null,
          Period: "",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "NoUpcoming",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: null,
          MinutesLeft: null,
          AdditionalInfo: null,
          ShowRemainingTime: false,
          Timestamp: "634643763490942971",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
      ],
    },
  };

  var demodataNextMeeting = {
    name: "Next Meeting",
    id: "demodata_NextMeeting",
    data: {
      ScreenInfo: screenInfo,
      Items: [
        {
          SequenceNumber: 1,
          IsLocked: false,
          MeetingId: null,
          MeetingPlace: null,
          Title: null,
          Period: "4:04pm - 5:45pm",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "Free",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "1",
          MinutesLeft: "41",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643966888901172",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 101,
        },
        {
          SequenceNumber: 2,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-b522-360d90f61bec",
          MeetingPlace: "Auditorium",
          Title: "TV campaign screening and party",
          Period: "5:45pm - 11:45pm",
          ReservationPeriod: "5:45 PM - 11:45 PM",
          Owner: "Helen Freely",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "41",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643966888901172",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
      ],
    },
  };

  var demodataNextMeetingNeedsConfirm = {
    name: "Next Meeting confirm",
    id: "demodata_NextMeetingConfirm",
    data: {
      ScreenInfo: screenInfo,
      Items: [
        {
          SequenceNumber: 1,
          IsLocked: false,
          MeetingId: null,
          MeetingPlace: null,
          Title: null,
          Period: "4:04pm - 5:45pm",
          ReservationPeriod: null,
          Owner: null,
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: null,
          Type: "Free",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "1",
          MinutesLeft: "41",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643966888901172",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 101,
        },
        {
          SequenceNumber: 2,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-b522-360d90f61bec",
          MeetingPlace: "Auditorium",
          Title: "TV campaign screening and party",
          Period: "5:45pm - 11:45pm",
          ReservationPeriod: "5:45 PM - 11:45 PM",
          Owner: "Helen Freely",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "41",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643966888901172",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: true,
          RemainingConfirmationSeconds: 9999999,
          MaxDurationMinutes: 0,
        },
      ],
    },
  };

  var demodataCurrentMeetingNeedsConfirm = {
    name: "Current Meeting confirm",
    id: "demodata_CurrentMeetingConfirm",
    data: {
      ScreenInfo: screenInfo,
      Items: [
        {
          SequenceNumber: 1,
          IsLocked: false,
          MeetingId: "a722783f-9d8e-4294-9551-daf0d6b20ab1",
          MeetingPlace: "Auditorium",
          Title: "Meeting with proNestor on pronestor Display",
          Period: "4:06pm - 5:15pm",
          ReservationPeriod: "4:06 PM - 5:15 PM",
          Owner: "David Jones",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Busy",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "1",
          MinutesLeft: "9",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: true,
          RemainingConfirmationSeconds: 899,
          MaxDurationMinutes: 99,
        },
        {
          SequenceNumber: 2,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-b522-360d90f61bec",
          MeetingPlace: "Auditorium",
          Title: "TV campaign screening and party",
          Period: "5:45pm - 11:45pm",
          ReservationPeriod: "5:45 PM - 11:45 PM",
          Owner: "Helen Freely",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
      ],
    },
  };
  var demodataSpontainiousMeeting = {
    name: "Spontaneous Meeting",
    id: "demodata_SpontainiousMeeting",
    data: {
      ScreenInfo: screenInfo,
      Items: [
        {
          SequenceNumber: 1,
          IsLocked: false,
          MeetingId: "a722783f-9d8e-4294-9551-daf0d6b20ab1",
          MeetingPlace: "Auditorium",
          Title: "Spontaneous meeting",
          Period: "4:06pm - 5:15pm",
          ReservationPeriod: "4:06 PM - 5:15 PM",
          Owner: "David Jones",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Busy",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "1",
          MinutesLeft: "9",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 899,
          MaxDurationMinutes: 99,
        },
        {
          SequenceNumber: 2,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-b522-360d90f61bec",
          MeetingPlace: "Auditorium",
          Title: "TV campaign screening and party",
          Period: "5:45pm - 11:45pm",
          ReservationPeriod: "5:45 PM - 11:45 PM",
          Owner: "Helen Freely",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
      ],
    },
  };

  var demodataBusyMeeting = {
    name: "Busy Meeting",
    id: "demodata_BusyMeeting",
    data: {
      ScreenInfo: screenInfo,
      Items: [
        {
          SequenceNumber: 1,
          IsLocked: false,
          MeetingId: "a722783f-9d8e-4294-9551-daf0d6b20ab1",
          MeetingPlace: "Auditorium",
          Title: "Meeting with proNestor on pronestor Display",
          Period: "4:06pm - 5:15pm",
          ReservationPeriod: "4:06 PM - 5:15 PM",
          Owner: "David Jones",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Busy",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "1",
          MinutesLeft: "9",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 899,
          MaxDurationMinutes: 99,
        },
        {
          SequenceNumber: 2,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-b522-360d90f61bec",
          MeetingPlace: "Auditorium",
          Title: "TV campaign screening and party",
          Period: "5:45pm - 11:45pm",
          ReservationPeriod: "5:45 PM - 11:45 PM",
          Owner: "Helen Freely",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
      ],
    },
  };

  var demodataLongText = {
    name: "Long Texts",
    id: "demodata_LongText",
    data: {
      ScreenInfo: screenInfo,
      Items: [
        {
          SequenceNumber: 1,
          IsLocked: false,
          MeetingId: "a722783f-9d8e-4294-9551-daf0d6b20ab1",
          MeetingPlace: "Auditorium is a room built to enable an audience to hear and watch",
          Title:
            "A meeting is a gathering of two or more people that has been convened for the purpose of achieving a common goal",
          Period: "4:06pm - 5:15pm",
          ReservationPeriod: "4:06 PM - 5:15 PM",
          Owner:
            "Maximilian MacArthur (A personal name identifies a specific unique and identifiable individual person, and may or may not include a middle name)",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Busy",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "1",
          MinutesLeft: "9",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 899,
          MaxDurationMinutes: 99,
        },
        {
          SequenceNumber: 2,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-b522-360d90f61bec",
          MeetingPlace: "Auditorium",
          Title:
            "Meetings may occur face to face or virtually, as mediated by communications technology, such as a telephone conference call, a skyped conference call or a videoconference",
          Period: "5:45pm - 11:45pm",
          ReservationPeriod: "5:45 PM - 11:45 PM",
          Owner:
            "Helen Freely(A name is a word or term used for identification. Names can identify a class or category of things, or a single thing, either uniquely, or within a given context)",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
      ],
    },
  };

  var demodataError = {
    name: "Error handle",
    id: "demodata_Error",
    data: {
      ScreenInfo: screenInfo,
      Items: [
        {
          SequenceNumber: 1,
          IsLocked: false,
          MeetingId: "a722783f-9d8e-4294-9551-daf0d6b20ab1",
          MeetingPlace: "Auditorium",
          Title: "Meeting with proNestor",
          Period: "4:06pm - 5:15pm",
          ReservationPeriod: "4:06 PM - 5:15 PM",
          Owner: "David Jones",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Busy",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Current",
          HoursLeft: "1",
          MinutesLeft: "9",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: true,
          RemainingConfirmationSeconds: 899,
          MaxDurationMinutes: 99,
        },
        {
          SequenceNumber: 2,
          IsLocked: false,
          MeetingId: "bb72e37c-bbe1-4d10-b522-360d90f61bec",
          MeetingPlace: "Auditorium",
          Title: "TV campaign screening and party",
          Period: "5:45pm - 11:45pm",
          ReservationPeriod: "5:45 PM - 11:45 PM",
          Owner: "Helen Freely",
          OwnerPhone: null,
          OwnerMobile: null,
          Contact: null,
          ContactPhone: null,
          ContactMobile: null,
          MeetingType: null,
          Participants: "3",
          Type: "Future",
          AlternativeTitle: null,
          AlternativeOwner: null,
          DateTimeType: "Future",
          HoursLeft: "7",
          MinutesLeft: "39",
          AdditionalInfo: null,
          ShowRemainingTime: true,
          Timestamp: "634643967612241016",
          IsPrivate: false,
          HasNextInfo: false,
          NextType: null,
          NextTitle: null,
          NextPeriod: null,
          NextOwner: null,
          NeedsConfirmation: false,
          RemainingConfirmationSeconds: 0,
          MaxDurationMinutes: 0,
        },
      ],
    },
    error: { Message: "Test" },
  };

  this.setup = function () {
    logThis("screenType:" + screenType);
    setupImpl();
  };

  function setDemo(el) {
    logThis("Demo item changed to " + el.name);
    logThis(el);

    if (el.name == "Long Texts") {
      el.data.ScreenInfo.ScreenDetail.Name = "Auditorium is a room built to enable an audience to hear and watch";
    } else {
      el.data.ScreenInfo.ScreenDetail.Name = "Demo screen";
    }

    if (el.name == "Long Text Demo") {
      el.data.ScreenInfo.ScreenDetail.Title = "Welcome to this demo screen with some long text examples";
    }

    currentDemo = el;
  }

  function isRandom() {
    return currentDemo && currentDemo.name == "Random";
  }

  function isScenario() {
    return currentDemo && currentDemo.type && currentDemo.type == "scenario";
  }

  function updateScreen() {
    if (settings.primaryElement.length > 0) {
      if (isRandom() || isScenario()) {
        logThis("update");
        screenHelper.getElements(settings.primaryElement).trigger("update");
      } else {
        logThis("updateOnce");
        screenHelper.getElements(settings.primaryElement).trigger("updateOnce");
      }
    }
  }

  function getRandomReception() {
    var n;
    var cases = 2; //this number defines how many case in the switch
    n = Math.random() * cases;
    n = Math.ceil(n);

    switch (n) {
      case 1:
        return demodataReceptionList;
      default:
        return demodataReceptionListShort;
    }
  }

  function getScenario() {
    var curr = currentDemo.steps[currentDemo.idx];
    currentDemo.idx = currentDemo.idx + 1;
    if (currentDemo.idx >= currentDemo.steps.length) {
      if (currentDemo.cycle) {
        currentDemo.idx = 0;
      } else {
        currentDemo = curr;
        stopPoll = true;
      }
    }
    logThis("currentDemo:" + currentDemo.name);
    return curr;
  }

  function getCurrentDemo() {
    if (isRandom()) {
      logThis("random demo");
      return getRandomReception();
    } else if (isScenario()) {
      logThis("scenario demo");
      return getScenario();
    }
    logThis("normal demo");
    logThis(currentDemo);
    return currentDemo || demodataNextMeeting;
  }

  this.getDemo = function () {
    stopPoll = false;
    var demoCookie = getDemoCookie("screenDemoCookieData");
    deleteDemoCookie("screenDemoCookieData");
    var curr = getCurrentDemo();
    logThis("Demo returned:" + curr.name);
    if (demoCookie) {
      curr.data.ScreenInfo = JSON.parse(demoCookie);
      screenType = curr.data.ScreenInfo.Type;
      logThis("screenType2:" + screenType);
    }
    if (stopPoll) {
      curr.data.ScreenInfo.Command = [{ Type: "UpdateInterval", Command: "-1" }];
    }
    return curr;
  };

  function setupImpl() {
    logThis("Demo setup");
    setupMarkup();
    setupDemos();
    logThis("screenType4:" + screenType);
    if (screenType == "Area") {
      setDemo(demodataAreaList);
    } else if (screenType == "Reception") {
      setDemo(demodataScenarioCycle);
    } else {
      setDemo(demodataFreeAllDay);
    }
  }

  function getDemoCookie(name) {
    var start = document.cookie.indexOf(name + "=");
    var len = start + name.length + 1;
    if (!start && name != document.cookie.substring(0, name.length)) {
      return null;
    }
    if (start == -1) {
      return null;
    }
    var end = document.cookie.indexOf(";", len);
    if (end == -1) {
      end = document.cookie.length;
    }
    return unescape(document.cookie.substring(len, end));
  }

  function deleteDemoCookie(name, path, domain) {
    if (getDemoCookie(name)) {
      document.cookie =
        name +
        "=" +
        (path ? ";path=" + path : "") +
        (domain ? ";domain=" + domain : "") +
        ";expires=Thu, 01-Jan-1970 00:00:01 GMT";
    }
  }

  function setupMarkup() {
    var container = $("body");
    var errorAlert = $('<div id="DemoAlert" style="position:absolute;top:0;left:0;z-index:9999999999999"></div>');

    /*var errorPanelLink = $('<a id="DemoPanelLink" href="#"></a>');
     */
    var errorImage = $('<img style="border:0;" src="' + imagePath + '" />');
    /* errorPanelLink.append(errorImage);*/
    errorAlert.append(errorImage);
    container.append(errorAlert);

    var errorWrapper = $(
      '<div id="DemoWrapper" style="width:300px;position:absolute;top:9px;left:34px;z-index:99999999999999;color:#000;border:1px solid #CCC; background-color:#EDEDED;opacity:0.9;padding:10px;) "></div>'
    );
    var navContainer = $("<div />");
    navContainer.css("width", "100%");
    var closeLink = $('<a id="closeLink" href="#">Pin</a>');
    closeLink.css("color", "#000");
    closeLink.click(function () {
      var el = $(this);
      if (el.html() == "Pin") {
        el.html("Unpin");
      } else {
        el.html("Pin");
      }
    });
    var pinContainer = $("<div/>");
    pinContainer.css("float", "left");
    pinContainer.append(closeLink);
    var forceCloseLink = $('<a id="forceCloseLink" href="#">Close</a>');
    forceCloseLink.css("color", "#000");
    forceCloseLink.click(function () {
      $("#DemoWrapper").toggle();
    });
    var closeContainer = $("<div/>");
    closeContainer.css("float", "right");
    closeContainer.css("text-align", "right");
    closeContainer.append(forceCloseLink);

    var hideLink = $('<a id="forceCloseLink" href="#">Hide</a>');
    hideLink.css("color", "#000");
    hideLink.click(function () {
      $("#DemoAlert").hide();
      $("#DemoWrapper").hide();
    });
    var hideContainer = $("<div/>");
    hideContainer.css("float", "right");
    hideContainer.css("text-align", "right");
    hideContainer.css("margin-right", "5px");
    hideContainer.append(hideLink);

    navContainer.append(pinContainer);
    navContainer.append(closeContainer);
    navContainer.append(hideContainer);

    errorWrapper.append(navContainer);
    var errorPanel = $('<div id="DemoPanel"></div>');
    errorPanel.append($("<br />"));
    errorWrapper.append(errorPanel);

    var errorPanelList = $('<div id="DemoPanelList"></div>');
    errorPanel.append(errorPanelList);
    container.append(errorWrapper);
    //errorAlert.hide();
    //errorPanelList.hide();
    errorWrapper.hide();

    errorImage
      .hover(
        function () {
          $(this).css("cursor", "pointer");
        },
        function () {
          $(this).css("cursor", "auto");
        }
      )
      .click(function (evt) {
        setSelectedDemo();
        errorWrapper.toggle();
      });
  }

  function setSelectedDemo() {
    $("#DemoPanel_ul > li").each(function () {
      if ($(this).attr("id") == currentDemo.id) {
        $(this).css("font-weight", "bold");
      } else {
        $(this).css("font-weight", "");
      }
    });
  }

  function setupDemos() {
    logThis("screenType3:" + screenType);
    if (settings.primaryElement) {
      if (screenType == "Area") {
        addToDemo(demodataAreaList);
        addToDemo(demodataAreaListWithBusy);
        addToDemo(demodataAreaListLong);
      } else if (screenType == "Reception") {
        addToDemo(demodataReceptionListShort);
        addToDemo(demodataReceptionList);
        addToDemo(demodataReceptionListEmpty);
        addToDemo(demodataRandom);
        addToDemo(demodataScenario);
        addToDemo(demodataScenarioCycle);
        addToDemo(demodataReceptionListShortLongText);
      } else {
        addToDemo(demodataFreeAllDay);
        addToDemo(demodataNextMeeting);
        addToDemo(demodataSpontainiousMeeting);
        addToDemo(demodataBusyMeeting);
        addToDemo(demodataLongText);
        addToDemo(demodataNextMeetingNeedsConfirm);
        addToDemo(demodataCurrentMeetingNeedsConfirm);
        addToDemo(demodataError);
      }
    } else {
      $("#DemoPanelList").append("No primary element found for demo");
    }
  }
  function getDemoElement() {
    var ulId = "DemoPanel_ul";
    var ulElement = $("#" + ulId);
    if (ulElement.length == 0) {
      ulElement = $('<ol id="' + ulId + '"></ol>');
      $("#DemoPanelList").append(ulElement);
      $("#DemoAlert").css("display", "block");
    }
    return ulElement;
  }

  function addToDemo(el) {
    logThis(el.name);
    var ulElement = getDemoElement();

    var span = $("<span class='DemoPanelLineDetail'>" + el.name + "</span>");
    span
      .hover(
        function () {
          $(this).css("cursor", "pointer");
        },
        function () {
          $(this).css("cursor", "auto");
        }
      )
      .click(function (evt) {
        setDemo(el);
        setSelectedDemo();
        updateScreen();

        if ($("#closeLink").html() == "Pin") {
          $("#DemoWrapper").toggle();
        }
      });

    var newLi = $('<li id="' + el.id + '"/>');
    newLi.append(span);
    ulElement.append(newLi);
  }

  function logThis(txt) {
    screenHelper.logThis(txt, this);
  }

  return this;
}
