﻿(function ($) {
  $.fn.screenDialog = function (options) {
    var screenApi = new ScreenApi();
    var settings = $.extend(
      {
        trigger: null,
        template: null,
        dataContainer: null,
        dataKey: "itemData",
        containerId: null,
        arrayRoomId: null,
        dataFormater: null /*function () { },*/,
        showOnEmptyData: false,
        onloaded: function (evt, element) {},
        localization: null,
        requiredData: null,
        requiredVisibleElements: null,
        dialogBehaviour: null,
        delay: null,
        primary: null,
        pincode: null,
        noPincode: false,
        auto: null,
        actions: null,
        onBeforeLoad: null,
      },
      options
    );

    if (settings.delay == null) {
      settings.delay = 100;
    }

    var screenHelper = new ScreenHelper();
    bindDetailClick(settings.trigger);

    function bindDetailClick(item) {
      if (item && item.data("isbound")) {
        return;
      } else if (item) {
        item.data("isbound", true);
      }
      if (settings.debugThis) {
        if (window.console) {
          alert(item.attr("id"));
        }
      }
      if (settings.actions) {
        setupEvents();
      }

      if (isTrigger(item)) {
        screenApi.activateInteractivity(
          {
            selector: item.selector,
            trigger: getClickEvent(),
            onShow: function (i, evt) {
              dialogAction(i, evt);
            },
            onHide: function (i, evt) {
              $.fancybox.close();
            },
            onBeforeShow: settings.onBeforeLoad,
            noPincode: settings.noPincode,
            handlebars: false,
            bypassVisibility: true,
          },
          function (accepted) {
            if (!accepted) {
              $.fancybox.close();
            }
          }
        );

      } else {
        console.log("show");
        logThis3(containterElement);
        logThis3(item);
        showDetail(settings.template, getData(null), containterElement(), null, item);
        logThis("g2");
      }
    }

    function dialogAction(thisItem, evt) {
      logThis3(thisItem);
      evt.stopPropagation();
      var itemData = getData(thisItem);
      if (requiredElementsAreVisible()) {
        showDetail(settings.template, itemData, containterElement(), evt, thisItem);
      }
    }

    function getClickEvent() {
      return "click";
    }

    function requiredElementsAreVisible() {
      if (settings.requiredVisibleElements) {
        return $(settings.requiredVisibleElements).length > 0;
      }
      return true;
    }
    function isTrigger(item) {
      if (item) {
        //logThis('isTrigger-length' + item.length);
        logThis("EL:" + item.attr("id") + "=" + item.is("visible"));
        if (item.length > 0 && item.is("visible")) {
          if (item.is("visible")) {
            return true;
          }
          return false;
        } else {
          return true;
        }
      }
      return false;
      //item && item.is(':visible');
    }
    function setupEvents() {
      $.each(settings.actions, function (index, value) {
        $.each(value.events, function (i) {
          value.events[i] = getClickEvent();

          logThis("Selector[" + value.selector + "]");
          logThis("Selector[" + (value.selector == "#okBook") + "]");
          if (value.selector == "#okBook") {
            logThis("Selector:[" + value.selector + "]" + $(value.selector).length);
          }
          $(document).on(value.events[i], value.selector, function (evt) {
            logThis("Selector[" + value.selector + "] binding to " + value.events[i]);
            logThis("logging evend");
            logThis(this);
            value.action(this);
          });
        });
      });
    }

    function getDataContainer(dataContainer) {
      return $.data(dataContainer, settings.dataKey);
    }

    function getData(item) {
      //screenApi.getPrimaryElementData()
      if (settings.dataFormater) {
        var crasythedata = settings.dataFormater(item);
        logThis("crasythedata");
        logThis(crasythedata);
        if (crasythedata) {
          return crasythedata;
        }
      }
      var dataContainer = settings.dataContainer;
      if (!dataContainer || dataContainer.length == 0) {
        dataContainer = item;

        if (dataContainer) {
          return dataContainer.data(settings.dataKey);
        }
      } else {
        if (settings.dataContainer && settings.dataContainer.data) {
          return settings.dataContainer.data(settings.dataKey);
        } else {
          return getDataContainer(settings.dataContainer);
        }
      }
      return null;
    }

    function containterElement() {
      return getElement(settings.containerId);
    }

    function getElement(id) {
      var el = $("#" + id);
      if (!el || el.length < 1) {
        el = $('<div id="' + id + '" />');
        $("body").append(el);
        el.wrap('<div style="display: none;" />');
      }
      return el;
    }

    function validData(item) {
      var valid = true;
      if (settings.requiredData) {
        valid = false;
        $.each(settings.requiredData, function (i) {
          if (item && item[settings.requiredData[i]] != null && item[settings.requiredData[i]] != "") {
            valid = true;
          }
        });
      }
      return valid;
    }

    function showDetail(template, item, container, evt, thisItem) {
      if (!validData(item)) {
        logThis("invalid data item");
        return;
      }
      logThis("show:tmpl(" + template + "), item(" + item + "), container(" + container + ")");
      if (template) {
        logThis("template exists");
        logThis(item);
        container.empty();
        template.tmpl(item, settings.localization).appendTo(container);
      }

      if (item || settings.showOnEmptyData) {
        if (settings.auto) {
          var autoResult = settings.auto();
          if (autoResult) {
            return;
          }
        }
        logThis("item exists:" + container.attr("id"));
        var dialogOptions = getDialogOptions();
        if (settings.delay) {
          setTimeout(function () {
            $('<a href="#' + container.attr("id") + '">Friendly description</a>')
              .fancybox(dialogOptions)
              .click();
            logThis("g3");
            settings.onloaded(evt, thisItem);
          }, settings.delay);
        } else {
          $('<a href="#' + container.attr("id") + '">Friendly description</a>')
            .fancybox(dialogOptions)
            .click();
          logThis("gg");
          settings.onloaded(evt, thisItem);
        }
      }
    }

    function getDialogOptions() {
      var defaultBehaviour = {
        beforeShow: function () {
          $(".fancybox-skin").css("background-color", "transparent");
          $(".fancybox-opened").css("-webkit-box-shadow", "none");
          $(".fancybox-opened").css("-moz-box-shadow", "none");
          $(".fancybox-opened").css("box-shadow", "none");
          $(".fancybox-skin").css("-webkit-box-shadow", "none");
          $(".fancybox-skin").css("-moz-box-shadow", "none");
          $(".fancybox-skin").css("box-shadow", "none");
        },
        openEffect: "none",
        closeEffect: "none",
        autoScale: true,
        type: "inline",
        padding: 1,
        overlayOpacity: 0.4,
        overlayColor: "#000",
        closeBtn: false,
        closeClick: false,
      };
      if (settings.dialogBehaviour) {
        $.extend(defaultBehaviour, settings.dialogBehaviour);
      }
      return defaultBehaviour;
    }

    function logThis(txt) {
      screenHelper.logThis(txt, this);
    }

    function logThis3(txt) {
      screenHelper.logThis3(txt, this);
    }
    return this;
  };
})(jQuery);
