//used like this in template.htm ${formatHelpers.cutText(Title,28,true)}
var formatHelpers = {
  cutText: function (txt, len, addEllipsis) {
    if (txt.length > len) {
      if (addEllipsis && txt.length > 3) {
        return txt.substring(0, len - 3) + "...";
      } else {
        return txt.substring(0, len);
      }
    }
    return txt;
  },
};

$(document).ready(function () {
  /* Get the access token from the Iadea Kiosk browser. */
  var body = { grant_type: "password", username: "admin", password: "" };
  $.post("http://localhost:8080/v2/oauth2/token", body)
    .done(function (data) {
      window["iadeaScreenAccessToken"] = data.access_token;
    }).fail(function () {
      /* The request might fail if this script doesn't run inside a Iadea Kiosk browser. In this case we simply don't use the it's features. */
      console.warn("Could not authenticate against Iadea Screen.");
    });
});

function getQbicToken() {
  $.ajax({
    url: 'http://localhost:8080/v1/oauth2/token',
    dataType: 'json',
    type: 'post',
    contentType: 'application/json;charset=utf-8',
    data: JSON.stringify({ "grant_type": "password", "username": "admin", "password": "12345678" }),
    processData: false,
  }).done(function (data) {
    window["qbicScreenAccessToken"] = data.access_token;
  }).fail(function () {
    /* The request might fail if this script doesn't run inside a Iadea Kiosk browser. In this case we simply don't use the it's features. */
    console.warn("Could not authenticate against qbic Screen.");
  });
}

function ScreenFeeder() {
  var settings = null;

  var contentParser = null;
  var sleeper = new ScreenSleep();
  var screenTemplate = new ScreenTemplate();
  var screenHelper = new ScreenHelper();
  var screenSettings = new ScreenSettings();
  var screenExternal = new ScreenExternal();
  var displayReload = new DisplayReload({ source: "screenFeeder" });
  var screenDataApi = new ScreenData();
  var screenApiUpdate = new ScreenApiUpdate();

  var screenGet = null;
  var screenData = null;

  var needToRefresh = false;
  var needsGlobalRefresh = false;
  var lastModified;
  var screenType = "Room";
  var idx = 0;
  var oldidx = 0;
  var tempIdx = 0;
  var max = 5;
  var total = 0;
  var pagingInterval = null;
  var pagingHandle = null;
  var inPaging = false;
  var inFreesPaging = false;
  var wasReleasing = false;
  var lastTimeStamp = null;
  var currentTimeStamp = null;
  var updateTriggered = false;
  var bypassTimestampCheck = false;
  var error500count = 0;
  var errorTimeoutCount = 0;
  var externalPath = "nothing";
  var firstRefreshLatency = 1100;
  var lastReload = new Date();

  var primaryItem, secondaryItem, clockItem, interactivityItem, screenInfoItem, statusArray, theList, defectOptions;
  var customerName = "";
  var isTrial = false;

  initialize();

  function initialize() {
    logThis("Feeder setup");
    settings = screenSettings.settings();
    screenGet = new ScreenGet({
      onError: function () {
        alert("error");
      },
    });
    contentParser = new ContentParser({ screenSettings: settings });
    setUpInterval(settings.update.interval);
    $("body").bind("update", function () {
      updateTriggered = true;
      logThis("update called");
      //screenDataApi.setIdle();
      refreshItems();
    });

    $("body").bind("freezePaging", function () {
      logThis("order1");
      logThis2("freezePaging");
      logThis("pagingHandle removed in freeze " + pagingHandle);
      // clearInterval(pagingHandle);
      tempInPaging = inPaging;
      inPaging = false;
      inFreesPaging = true;
      wasReleasing = false;
      tempIdx = idx;
      idx = 0;
      writeInfo("freezePaging");
    });

    $("body").bind("releaseFreezePaging", function () {
      logThis("order2");
      if (inFreesPaging) {
        logThis2("releaseFreezePaging");
        inPaging = tempInPaging;
        inFreesPaging = false;
        wasReleasing = true;
        idx = oldidx;
        if (inPaging) {
          logThis("setupPaging44");
          // setupPaging();
        }
      }
      writeInfo("releaseFreezePaging");
      setTimeout(function () {
        wasReleasing = false;
      }, 1000);
    });

    $("body").bind("updateOnce", function () {
      logThis("updateOnce called");
      refreshItems();
    });
    $("body").bind("triggerOnUpdate", function () {
      settings.onUpdate(screenData);
    });

    //ajax defaults
    $.ajaxSetup({
      dataType: "json",
    });

    $("body").data("ready", true);
    new ScreenInteract();
  }

  function setUpInterval(interval) {
    logThis("interval set to:" + interval);
    checkRefresh();
    callUpdate(interval);
    screenDataApi.setInterval(interval);
  }

  function callUpdate(interval) {
    $.when(refreshItems()).always(function () {
      setTimeout(function () {
        checkRefresh();
        callUpdate(interval);
      }, 1000 * interval);
    });
  }

  function checkRefresh() {
    if (!settings.refresh) {
      return;
    }

    var refreshReason = "PeriodicRefresh";

    var d = new Date();
    var n = d.getHours();

    var diff = d - lastReload;

    if (diff < 60 * 60 * 1000) {
      return;
    }

    if (settings.refresh.refresh1) {
      if (n == settings.refresh.refresh1) {
        displayReload.doReloadIfSafe(refreshReason);
      }
    }

    if (settings.refresh.refresh2) {
      if (n == settings.refresh.refresh2) {
        displayReload.doReloadIfSafe(refreshReason);
      }
    }

    if (settings.refresh.refresh3) {
      if (n == settings.refresh.refresh3) {
        displayReload.doReloadIfSafe(refreshReason);
      }
    }

    if (settings.refresh.refresh4) {
      if (n == settings.refresh.refresh4) {
        displayReload.doReloadIfSafe(refreshReason);
      }
    }
  }

  function getItemData() {
    debugLog("&nbsp;&nbsp;&nbsp;&nbsp;getItemData");
    var securityToken = screenHelper.extractSecurityToken();
    if (!isDemo()) {
      var result;
      if (ScreenModule.data.wasClientupdate()) {
        result = ScreenModule.data.getScreenData();
      } else {
        result = screenGet.get(settings.update.updatePath, {
          securityToken: securityToken,
          TimeStamp: screenHelper.getTimeStamp(),
        });
      }
      if (settings.debug && settings.debug.showFetchTimestamp) {
        addFetchTimestamp();
      }
      return result;
    } else {
      return screenGet.getDemo(settings.demo);
    }
  }

  function addFetchTimestamp() {
    setFetchTimestamp();
  }

  function addToFooter(id, text, wrapperstyle, innerstyle) {
    var div = $("#" + id);
    if (div.length == 0) {
      div = $('<div id="' + id + '" style="' + wrapperstyle + '">');
      $("body").append(div);
    }
    div.empty();
    var fontColor = "#FFF";
    var fontColor2 = "#000";
    var fontFamily = "Verdana";
    var divFooterText = $(
      '<div id="' +
        id +
        'Shadow" style="z-index:999999999999999;position:absolute;bottom:1px;text-align:left;color:' +
        fontColor2 +
        ";font-family:" +
        fontFamily +
        ";" +
        innerstyle +
        '">' +
        text +
        "</div>"
    );

    div.append(divFooterText);
    var divFooterText2 = $(
      '<div id="' +
        id +
        'Text" style="z-index:9999999999999999;position:absolute;bottom:0;text-align:left;color:' +
        fontColor +
        ";font-family:" +
        fontFamily +
        ";" +
        innerstyle +
        '">' +
        text +
        "</div>"
    );

    div.append(divFooterText2);
  }

  function setFetchTimestamp() {
    addToFooter(
      "proNestorFetchTimestamp",
      screenHelper.getFormatedTimeStamp(),
      "position:absolute;bottom:0;width:100%;margin: 0 auto;",
      "left:250px;font-size: 10px;"
    );
  }

  function setUpdatedTimestamp() {
    addToFooter(
      "proNestorUpdatedTimestamp",
      screenHelper.getFormatedTimeStamp(),
      "position:absolute;bottom:0;width:100%;margin: 0 auto;",
      "left:370px;font-size: 10px;"
    );
  }

  function isHebrew() {
    return settings.localization.MinutesLeftFormat == "דקות";
  }

  function refreshItems() {
    setActionIndicator("#0000FF");
    debugLog("<div class='no-class'></div>");
    debugLog(new Date() + "<br/>");
    debugLog("refreshItems");

    return $.when(getItemData())
      .then(function (data) {
        $(document).trigger("screen:clearError");
        remove500Alert();
        removeTimeoutAlert();
        error500count = 0;
        errorTimeoutCount = 0;
        showInteractivity();
        debugLog("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;getItemData:success");
        logThis("textStatus:success");
        if (settings.dataFilter) {
          data = settings.dataFilter(data);
        }
        if (typeof window.displayDataFetched === "function") {
          window.displayDataFetched(data);
        }
        success(data);
      }).fail(function (jqXhr, textStatus, errorThrown) {
        console.log(jqXhr);
        if (typeof window.displayDataFetchError === "function") {
          window.displayDataFetchError(jqXhr, textStatus, errorThrown);
        }
        if (jqXhr == "request lost" || jqXhr.status == "500") {
          error500count += 1;
          var data2 = getErrorData();
          if (data2) {
            bypassTimestampCheck = true;
            success(data2, true);
            if (error500count > 4) {
              set500Alert();
            }
            bypassTimestampCheck = false;
            return;
          }
        } else {
          error500count = 0;
        }

        if (jqXhr == "request timeout") {
          console.log("setup timeout message");
          errorTimeoutCount += 1;
          var data3 = getErrorData();
          if (data3) {
            bypassTimestampCheck = true;
            success(data3, true);
            if (errorTimeoutCount > 1) {
              setTimeoutAlert();
            }
            if (errorTimeoutCount > 99) {
              settings.onTimeoutThreshold("TimeoutThreshold");
            }
            bypassTimestampCheck = false;
            return;
          }
        } else {
          errorTimeoutCount = 0;
        }

        hideInteractivity();
        setActionIndicator("#FF0000");
        debugLog("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;getItemData:fail", false);
        logThis("textStatus:" + textStatus + "[" + jqXhr.status + "]");
        logThis(jqXhr);
        if (jqXhr.status == "404") {
          setInCloseDownMode();
        }
        fail(jqXhr, textStatus, errorThrown);
      });
  }

  function getErrorData() {
    if (screenData) {
      return screenData;
    } else {
      //  alert('screenData is null');
    }
  }

  function showInteractivity() {
    getInteractionElement().show();
  }

  function hideInteractivity() {
    getInteractionElement().hide();
  }

  function setInCloseDownMode() {
    settings.onScreenNotFound();
  }
  function fail(jqXhr, textStatus, errorThrown) {
    ajaxErrorLog("GetDataFail", jqXhr, textStatus, errorThrown);
  }
  function injectData(data) {
    if (settings.inject) {
      data = settings.inject(data);
    }
    return data;
  }

  function manipulateData(data) {
    var clock = contentParser.extractClockContent(data);
    data.ScreenInfo.clock = clock.TimeString;
    data.ScreenInfo.date = clock.DateString;
    return data;
  }

  function success(data, bypassAjaxRecovery) {
    if (!bypassAjaxRecovery) {
      settings.onAjaxRecover();
    }
    data = manipulateData(data);
    data = injectData(data);
    screenData = data;
    screenDataApi.storeScreenData(data);
    if (screenData) {
      extractData();
      if (typeof customTemplateScript == "function") {
      } else {
        updateTemplates();
      }
      setBranding();
      setNoContainerAlert();
      handleFrameColor(screenData);
      settings.onUpdate(screenData);
      if (settings.debug && settings.debug.showUpdatedTimestamp) {
        setUpdatedTimestamp();
      }

      PRONESTORDISPLAY.executingCommand = false;
      ScreenModule.data.setClientUpdate(false);
    } else {
      screenHelper.logThis("no screenData");
    }
  }

  function isDemo() {
    return settings.demo;
  }

  function ajaxErrorLog(source, jqXhr, textStatus, errorThrown) {
    settings.onAjaxError(source, jqXhr, textStatus, errorThrown);
  }
  function clearPager() {
    updatePager(true);
  }
  function updatePager(clear) {
    var totalPages = Math.ceil(total / max);
    var tempMax = 0;
    var currentPage = 1;
    var pageCount = 1;
    var pageElements = new Array();

    if (max < 0) {
      max = 99999999999;
    }
    while (total > tempMax) {
      tempMax += max;
      if (idx >= tempMax) {
        currentPage++;
      }

      pageElements.push({ Nr: pageCount++, Selected: false });
    }
    for (var i = 0; i < pageElements.length; i++) {
      if (pageElements[i]["Nr"] == currentPage) {
        pageElements[i]["Selected"] = true;
      }
    }

    var pageInfo = {
      Page: currentPage,
      Total: totalPages,
      PageElements: pageElements,
      Empty: clear,
    };

    setupContent("pagerTemplate", pageInfo, settings.paging.pager);
    logThis("updatePager:" + currentPage + " of " + totalPages);
  }
  function setupPaging() {
    logThis("setting up paging");
    if (pagingInterval == null) {
      logThis("paging disabled");
      return;
    }
    logThis("pagingHandle:" + pagingHandle);
    if (pagingHandle != null) {
      window.clearInterval(pagingHandle);
      logThis("pagingHandle removed:" + pagingHandle);
    }
    inPaging = true;
    pagingHandle = setInterval(function () {
      logThis2("inFreesPaging:" + inFreesPaging);
      if (inFreesPaging) {
        return;
      }
      logThis("pagingHandle run on:" + pagingHandle);
      logThis("wasReleasing" + wasReleasing);
      if (wasReleasing) {
        oldidx = idx;
        idx += max;
        logThis("idx is " + idx);
        if (idx >= total) {
          idx = 0;
        }
        wasReleasing = false;
      }
      logThis("jsonResultkk");
      writeInfo("setupPaging");
      logThis("updatePager setInterval");
      updatePager();
      logThis("jsonResult5");
      primaryItem = contentParser.extractPrimaryContent(screenData, idx, max);
      oldidx = idx;
      idx += max;
      logThis("idx is " + idx);
      if (idx >= total) {
        idx = 0;
      }
      logThis("idx is now " + idx);
      setupContent("primaryBusyTemplate", primaryItem, screenHelper.getElements(settings.elements.primary));
      setupStockTicker();
      setupTextCut();
      setupTextResize();
    }, pagingInterval);
    logThis("pagingHandle renewed:" + pagingHandle);
  }

  function setMax() {
    if (settings.paging) {
      if (settings.paging && settings.paging.elements) {
        logThis("window.height_NOI");
        max = settings.paging.elements;
      } else if (settings.paging && settings.paging.elementHeight) {
        //external
        var subtractExternalHeight = 0;
        if (settings.external && settings.external.id) {
          subtractExternalHeight = settings.external.siteHeight;
          var refreshExternal = settings.external.siteUrl != externalPath || settings.external.refresh;
          externalPath = settings.external.siteUrl;
          screenExternal.setupExternal(
            settings.external.id,
            externalPath,
            settings.external.siteHeight,
            settings.external.style,
            settings.external.scroll,
            refreshExternal
          );
        }
        //external end
        var containerHeight = $(window).height() - subtractExternalHeight;
        logThis("window.height():" + containerHeight);
        var primariPosition = screenHelper.getElements(settings.elements.primary).first().position().top;
        if (settings.paging.startPosition) {
          primariPosition = settings.paging.startPosition;
        }
        logThis("debugHH-primariPosition" + primariPosition);
        if (settings.paging.bottomPadding) {
          containerHeight -= settings.paging.bottomPadding;
        }
        logThis("debugHH-containerHeight" + containerHeight);
        logThis("debugHH-settings.paging.elementHeight" + settings.paging.elementHeight);

        max = Math.floor((containerHeight - primariPosition) / settings.paging.elementHeight);
        logThis("max:" + max);
      }
      if (settings.paging && settings.paging.interval) {
        pagingInterval = settings.paging.interval;
      }
    } else {
      max = 99999999999;
    }
  }
  function stopPaging() {
    logThis("stopaging");
    inPaging = false;
    window.clearInterval(pagingHandle);
    clearPager();
  }
  function executeScreenCommand(command) {
    for (var i = 0; i < command.length; i++) {
      if (command[i].Type == "UpdateInterval") {
        if (command[i].Command != "-1") {
          setInterval(command[i].Command);
        }
      }
    }
  }

  function writeInfo(msg) {
    return;
    if ($("#infobox").length == 0) {
      $("body").prepend('<input id="infobox" type="text" style="width:500px"/>');
    }
    clearInfo();
    if (msg) {
      setInfo(msg);
      addInfo("idx=" + idx);
    } else {
      setInfo("idx=" + idx);
    }
    addInfo("oldidx=" + oldidx);
    addInfo("max=" + max);
    addInfo("total=" + total);
    addInfo(inPaging);
    addInfo(inPaging);
  }
  function setInfo(txt) {
    $("#infobox").val(txt);
  }
  function addInfo(txt) {
    $("#infobox").val($("#infobox").val() + "|" + txt);
  }

  function clearInfo() {
    $("#infobox").empty();
  }

  function extractReceptionPrimaryData() {
    logThis2("extractReceptionPrimaryData");
    writeInfo("extractReceptionPrimaryData");
    setMax();
    logThis(idx + "." + max);
    logThis("jsonResult0");
    primaryItem = contentParser.extractPrimaryContent(screenData, idx, max);
    logThis("jsonResultx");
    total = contentParser.extractItemsCount(screenData, idx, max);
    logThis("jsonResulty");
    if (idx > total) {
      idx = 0;
    }
    logThis("setupPaging1:" + wasReleasing);
    logThis("setupPaging2:" + inPaging);
    if (settings.paging && updateTriggered) {
      logThis2("extractReceptionPrimaryData - 1");
      updateTriggered = false;
      primaryItem = contentParser.extractPrimaryContent(screenData, idx, max);
      setupContent("primaryBusyTemplate", primaryItem, screenHelper.getElements(settings.elements.primary));
    }
    if (settings.paging && !inPaging && !inFreesPaging) {
      logThis2("extractReceptionPrimaryData - 2");
      if (total > max && pagingInterval != null) {
        updatePager();
        idx += max;
        if (total > idx) {
          setupPaging();
        } else if (pagingHandle != null) {
          primaryItem = contentParser.extractPrimaryContent(screenData, 0, max);
          stopPaging();
        }
      } else if (pagingHandle != null) {
        primaryItem = contentParser.extractPrimaryContent(screenData, 0, max);
        stopPaging();
      }
      setupContent("primaryBusyTemplate", primaryItem, screenHelper.getElements(settings.elements.primary));
    } else if (settings.paging && total <= max) {
      logThis2("extractReceptionPrimaryData - 3");
      logThis("jsonResult3");
      primaryItem = contentParser.extractPrimaryContent(screenData, 0, max);
      if (!wasReleasing) {
        stopPaging();
      }
    } else {
      logThis2("extractReceptionPrimaryData - 4");
    }
    logThis2("extractReceptionPrimaryData - done");
    wasReleasing = false;
    logThis("wasReleasing2:" + wasReleasing);
    if (idx > total) {
      idx = 0;
    }
    logThis("jsonResultz");
  }

  function setSecurity(security) {
    $("body").data("security", security);
  }

  window.handleFrameColor = function (screenData) {
    if (screenData !== null && screenData.ScreenInfo && screenData.ScreenInfo.QbicScreen && !window["qbicScreenAccessToken"]) {
      getQbicToken();
    }
    if (screenData.Items.length > 0) {
      var status = screenData.Items[0].Type.toLowerCase();
      var intensity = screenData.ScreenInfo.FrameColorIntensity;
      if (sleeper.isSleeping()) {
        intensity = 0;
      }

      var audioCookie = $.cookie("audio");
      var soundSource = null;
      var color = null;
      if (screenData.ScreenInfo.IsFrameColorEnabled && intensity != 0) {
        if (
          /^busy/.test(status) ||
          /^unavailablenow/.test(status) ||
          /^closedallday/.test(status) ||
          /^closed/.test(status) ||
          /^futurehidden/.test(status) ||
          /^future/.test(status) ||
          /^unavailable/.test(status) ||
          /^busyhidden/.test(status)
        ) {
          soundSource = intensity + "_RED.wav";
          color = "#ff0000";
        } else {
          soundSource = intensity + "_GREEN.wav";
          color = "#00ff00";
        }
      } else if (audioCookie && audioCookie == "play") {
        soundSource = "0_STOP.wav";
        color = "#0000ff";
      }

      if (color) {
        changeLedColor(color);
      }

      if (soundSource) {
        playSound(soundSource);
      }
    }
  };

  function hexToRgb(hex) {
    var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
    return result ? {
      r: parseInt(result[1], 16),
      g: parseInt(result[2], 16),
      b: parseInt(result[3], 16)
    } : null;
  }

  function changeLedColor(hex) {
    if (window["iadeaScreenAccessToken"]) {
      var body = { id: 0, name: "frame", brightness: 1.0, color: hex };
      $.post("http://localhost:8080/v2/hardware/light?access_token=" + window["iadeaScreenAccessToken"], body);
    }

    if (window["qbicScreenAccessToken"]) {
      var rgb = hexToRgb(hex);

      $.ajax({
        url: 'http://localhost:8080/v1/led/front_led',
        dataType: 'json',
        type: 'post',
        contentType: 'application/json;charset=utf-8',
        data: JSON.stringify({ "red": rgb.r, "green": rgb.g, "blue": rgb.b }),
        processData: false,
        headers: { "Authorization": 'Bearer ' + window["qbicScreenAccessToken"] },
      });

      $.ajax({
        url: 'http://localhost:8080/v1/led/side_led',
        dataType: 'json',
        type: 'post',
        contentType: 'application/json;charset=utf-8',
        data: JSON.stringify({ "red": rgb.r, "green": rgb.g, "blue": rgb.b }),
        processData: false,
        headers: { "Authorization": 'Bearer ' + window["qbicScreenAccessToken"] },
      });
    }
  }

  function playSound(soundSource) {
    var audioFolder = settings.audio.audioFolder;
    if (isPlaying($("audio")[0])) {
      setTimeout(function () {
        playSound(soundSource);
      }, 500);
    } else {
      if (window.android && $.isFunction(window.android.playAndroidSound)) {
        window.android.playAndroidSound(soundSource);
      } else {
        $("audio")[0].src = audioFolder + soundSource;
        $("audio")[0].play();
      }

      $.cookie("audio", soundSource == "0_STOP.wav" ? null : "play");
    }
  }

  function isPlaying(audioelem) {
    return !audioelem.paused && audioelem.error === null;
  }

  function extractData() {
    setSecurity(contentParser.extractSecurity(screenData));
    logThis("jsonResultmm");
    currentTimeStamp = contentParser.extractTimeStamp(screenData);

    if (currentTimeStamp && lastTimeStamp === currentTimeStamp && !bypassTimestampCheck) {
      setTimeStampAlert();
      setActionIndicator("#FFD800");
    } else {
      setActionIndicator("#00FF00");
    }
    lastTimeStamp = currentTimeStamp;
    var command = contentParser.extractScreenCommand(screenData);
    logThis(command);
    if (command) {
      executeScreenCommand(command);
    }
    screenType = contentParser.extractScreenType(screenData);
    logThis("screenType:" + screenType);

    if (screenData.Items) {
      if (screenType != "Room") {
        extractReceptionPrimaryData();
      } else {
        logThis("jsonResult4");
        primaryItem = contentParser.extractPrimaryContent(screenData);
        theList = contentParser.extractList(screenData, 0, 99999999);
      }

      secondaryItem = contentParser.extractSecondaryContent(screenData);
      if (screenType == "Room") {
        interactivityItem = contentParser.extractPrimaryInteractivity(screenData);
      }
    }

    if (!screenData.Items || screenData.Items.length < 1) {
      //external
      var subtractExternalHeight = 0;
      if (settings.external && settings.external.id) {
        subtractExternalHeight = settings.external.siteHeight;
        var refreshExternal = settings.external.siteUrl != externalPath || settings.external.refresh;
        externalPath = settings.external.siteUrl;
        screenExternal.setupExternal(
          settings.external.id,
          externalPath,
          settings.external.siteHeight,
          settings.external.style,
          settings.external.scroll,
          refreshExternal
        );
      }
      //external end

      if (!screenData.ScreenInfo.CanBeActivated) {
        setNoLicenseAlert();
      }

      screenHelper.logThis("no Items, check license");
    }

    clockItem = contentParser.extractClockContent(screenData);
    screenInfoItem = contentParser.extractScreenInfoContent(screenData);
    statusArray = contentParser.extractStatusArray(screenData);
    defectOptions = contentParser.extractDefectOptions(screenData);
    var dataLastModified = contentParser.extractLastModifiedTime(screenData);
    logThis("dataLastModified:" + dataLastModified);
    var dataRefreshContainer = contentParser.extractRefreshContainer(screenData);
    logThis("dataRefreshContainer:" + dataRefreshContainer);
    isTrial = contentParser.extractTrial(screenData);
    customerName = contentParser.extractCustomerName(screenData);

    if (dataRefreshContainer) {
      inGlobalRefreshMode("DataRefreshContainer(" + dataRefreshContainer + ")");
    }

    if (lastModified && lastModified != dataLastModified) {
      logThis("lastModified:" + lastModified);
      logThis("dataLastModified:" + dataLastModified);
      inRefreshMode("LastModifiedTime(" + lastModified + " to " + dataLastModified + ")");
    } else {
      lastModified = dataLastModified;
      notInRefreshMode();
    }

    screenHelper.logThis("needToRefresh:" + needToRefresh);
  }
  function findCss(el, css) {
    var font = "";

    if (!font || font == "") {
      el.children().each(function () {
        if (font == "") {
          font = $(this).css(css);
        }
      });
    }
    if (!font || font == "") {
      el.children().each(function () {
        font = findCss($(this), css);
      });
    }
    if (!font || font == "") {
      if (el.css(css)) {
        font = el.css(css);
      }
    }
    return font;
  }

  function containsForsceShowContent() {
    return document.URL.indexOf("forceShowContent=true") != -1;
  }

  function setNoLicenseAlert() {
    var branding = $("#proNestorLicenseDisplay");
    if (branding.length == 0) {
      var fontColor = "#FF0000"; //findCss(settings.elements.primary, 'color');
      var fontFamily = "Verdana"; //findCss(settings.elements.primary, 'font-family');
      var bg = "#FBFF8E";
      var text = document.URL;
      var redirectTime = 10;
      var re = /showcontent/gi;
      text = text.replace(re, "Show", "gi");
      //window.location = text;

      var message =
        "You do not have a license to display this screen, please log into administration and only activate as many displays as you have licenses for.";
      var div = $(
        '<div id="proNestorLicenseDisplay" style="padding-top:15px;padding-bottom:15px;position:absolute;top:0;right:0;width:100%;background:' +
          bg +
          '">'
      );
      var divFooterText = $(
        '<div style="font-size: 15px;text-align:center;font-weight:bold;color:' +
          fontColor +
          ";font-family:" +
          fontFamily +
          ';">' +
          message +
          "</div>"
      );
      div.append(divFooterText);

      $("body").append(div);
    }
  }

  function setActionIndicator(color) {
    if (settings.activityIndication) {
      if (color == "#0000FF") {
        setActionIndicatorStart(color);
      } else {
        setActionIndicatorEnd(color);
      }
    }
  }

  function setActionIndicatorStart(color) {
    var branding = $("#proNestorTimeStampDisplay");
    if (branding.length == 0) {
      var fontColor = color; //findCss(settings.elements.primary, 'color');
      var fontFamily = "Verdana"; //findCss(settings.elements.primary, 'font-family');
      var bg = "transparent";
      var text = document.URL;
      var redirectTime = 1;
      var re = /showcontent/gi;
      text = text.replace(re, "Show", "gi");

      var message = "&bull;";
      var div = $(
        '<div id="proNestorTimeStampDisplay" style="padding-top:5px;padding-bottom:5px;position:absolute;top:0;right:0;width:100%;background:' +
          bg +
          '">'
      );
      var divFooterText = $(
        '<div style="font-size: 30px;text-align:left;font-weight:bold;color:' +
          fontColor +
          ";font-family:" +
          fontFamily +
          ';">' +
          message +
          "</div>"
      );
      div.append(divFooterText);

      $("body").append(div);
    }
    setTimeout(function () {
      $("#proNestorTimeStampDisplay").fadeOut("slow");
      setTimeout(function () {
        $("#proNestorTimeStampDisplay").remove();
      }, 1000);
    }, redirectTime * 1000);
  }

  function setActionIndicatorEnd(color) {
    var branding = $("#proNestorTimeStampDisplayEnd");
    if (branding.length == 0) {
      var fontColor = color; //findCss(settings.elements.primary, 'color');
      var fontFamily = "Verdana"; //findCss(settings.elements.primary, 'font-family');
      var bg = "transparent";
      var text = document.URL;
      var redirectTime = 1;
      var re = /showcontent/gi;
      text = text.replace(re, "Show", "gi");

      var message = "&bull;";
      var div = $(
        '<div id="proNestorTimeStampDisplayEnd" style="padding-top:5px;padding-bottom:5px;position:absolute;top:0;right:0;width:100%;background:' +
          bg +
          '">'
      );
      var divFooterText = $(
        '<div style="padding-left:10px;font-size: 30px;text-align:left;font-weight:bold;color:' +
          fontColor +
          ";font-family:" +
          fontFamily +
          ';">' +
          message +
          "</div>"
      );
      div.append(divFooterText);

      $("body").append(div);
    }
    setTimeout(function () {
      $("#proNestorTimeStampDisplayEnd").fadeOut("slow");
      setTimeout(function () {
        $("#proNestorTimeStampDisplayEnd").remove();
      }, 1000);
    }, redirectTime * 1000);
  }

  function remove500Alert() {
    var branding = $("#proNestor500Display");
    if (branding.length == 1) {
      $("#proNestor500Display").remove();
      settings.onAjaxRecover();
    }
  }

  function remove500AlertNoRelease() {
    var branding = $("#proNestor500Display");
    if (branding.length == 1) {
      $("#proNestor500Display").remove();
    }
  }

  function removeTimeoutAlert() {
    var branding = $("#proNestorTimeoutDisplay");
    if (branding.length == 1) {
      $("#proNestorTimeoutDisplay").remove();
      settings.onAjaxRecover();
    }
  }

  function removeTimeoutAlertNoRelease() {
    var branding = $("#proNestorTimeoutDisplay");
    if (branding.length == 1) {
      $("#proNestorTimeoutDisplay").remove();
    }
  }
  function setTimeoutAlert() {
    removeTimeoutAlertNoRelease();
    var branding = $("#proNestorTimeoutDisplay");
    if (branding.length == 0) {
      var fontColor = "#FF0000"; //findCss(settings.elements.primary, 'color');
      var fontFamily = "Verdana"; //findCss(settings.elements.primary, 'font-family');
      var bg = "#FBFF8E";

      var message = "Server has failed to receive new data for " + errorTimeoutCount + " minutes due to timeout";
      var div = $(
        '<div id="proNestorTimeoutDisplay" style="padding-top:15px;padding-bottom:15px;position:absolute;top:0;right:0;width:100%;background:' +
          bg +
          '">'
      );
      var divFooterText = $(
        '<div style="font-size: 15px;text-align:center;font-weight:bold;color:' +
          fontColor +
          ";font-family:" +
          fontFamily +
          ';">' +
          message +
          "</div>"
      );
      div.append(divFooterText);

      $("body").append(div);
    }
  }
  function set500Alert() {
    remove500AlertNoRelease();
    var branding = $("#proNestor500Display");
    if (branding.length == 0) {
      var fontColor = "#FF0000"; //findCss(settings.elements.primary, 'color');
      var fontFamily = "Verdana"; //findCss(settings.elements.primary, 'font-family');
      var bg = "#FBFF8E";

      var message = "Server has failed to receive new data for " + error500count + " minutes due to connection issues";
      var div = $(
        '<div id="proNestor500Display" style="padding-top:15px;padding-bottom:15px;position:absolute;top:0;right:0;width:100%;background:' +
          bg +
          '">'
      );
      var divFooterText = $(
        '<div style="font-size: 15px;text-align:center;font-weight:bold;color:' +
          fontColor +
          ";font-family:" +
          fontFamily +
          ';">' +
          message +
          "</div>"
      );
      div.append(divFooterText);

      $("body").append(div);
    }
  }

  function setTimeStampAlert() {
    return;
  }

  function setNoContainerAlert() {
    if (!isInIframe() && !containsForsceShowContent()) {
      var branding = $("#proNestorSecureDisplay");
      if (branding.length == 0) {
        var fontColor = "#FF0000"; //findCss(settings.elements.primary, 'color');
        var fontFamily = "Verdana"; //findCss(settings.elements.primary, 'font-family');
        var bg = "#FBFF8E";
        var text = document.URL;
        var redirectTime = 10;
        var re = /showcontent/gi;
        text = text.replace(re, "Show", "gi");

        var message =
          "Running in non-container mode. Please use ~/Display.mvc/Show/&lt;id&gt; instead of ~/Display.mvc/ShowContent/&lt;id&gt; URL<br/> Redirecting to " +
          text +
          " in " +
          redirectTime +
          " sec";
        var div = $(
          '<div id="proNestorSecureDisplay" style="padding-top:15px;padding-bottom:15px;position:absolute;top:0;right:0;width:100%;background:' +
            bg +
            '">'
        );
        var divFooterText = $(
          '<div style="font-size: 15px;text-align:center;font-weight:bold;color:' +
            fontColor +
            ";font-family:" +
            fontFamily +
            ';">' +
            message +
            "</div>"
        );
        div.append(divFooterText);

        $("body").append(div);
      }
      setTimeout(function () {
        var text2 = document.URL;
        var re2 = /showcontent/gi;
        text2 = text2.replace(re2, "Show", "gi");
        window.location = text2;
      }, redirectTime * 1000);
    }
  }

  function setBranding() {
    var branding = $("#proNestorDisplayBranding");
    if (branding.length == 0) {
      var fontColor = "#FFF";
      var fontColor2 = "#000";
      var fontFamily = "Verdana";
      var div = $('<div id="proNestorDisplayBranding" style="position:absolute;bottom:0;left:0;width:100%;">');
      if (customerName && customerName.length > 0 && tenantSettings.showDisplayScreenFooter) {
        var licenseText = settings.localization.LicensedTo + " " + customerName;
        if (isHebrew()) {
          licenseText = customerName + " " + settings.localization.LicensedTo;
        }
        var divFooterText = $(
          '<div id="footertext555a" style="z-index:999999999999999;position:absolute;bottom:1px;right:1px;margin-right:63px; margin-top:30px;font-size: 15px;text-align:left;color:' +
            fontColor2 +
            ";font-family:" +
            fontFamily +
            ';">' +
            licenseText +
            "</div>"
        );

        div.append(divFooterText);
        var divFooterText2 = $(
          '<div id="footertext555b" style="z-index:9999999999999999;position:absolute;bottom:0;right:0;margin-right:63px; margin-top:30px;font-size: 15px;text-align:left;color:' +
            fontColor +
            ";font-family:" +
            fontFamily +
            ';">' +
            licenseText +
            "</div>"
        );

        div.append(divFooterText2);
      }
      if (tenantSettings.showDisplayScreenFooter) {
        var poweredByText = settings.localization.PoweredBy + " Pronestor";
        if (isHebrew()) {
          poweredByText = "Pronestor " + settings.localization.PoweredBy;
        }
        var divFooterLicense2 = $(
          '<div id="footertextlicense555a" style="z-index:999999999999999;position:absolute;bottom:0;left:0;margin-left:40px; margin-top:30px;font-size: 15px;text-align:right;color:' +
            fontColor2 +
            ";font-family:" +
            fontFamily +
            ';">' +
            poweredByText +
            "</div>"
        );

        div.append(divFooterLicense2);
        var divFooterLicense = $(
          '<div id="footertextlicense555b" style="z-index:9999999999999999;position:absolute;bottom:-1px;left:1px;margin-left:40px; margin-top:30px;;font-size: 15px;text-align:right;color:' +
            fontColor +
            ";font-family:" +
            fontFamily +
            ';">' +
            poweredByText +
            "</div>"
        );

        div.append(divFooterLicense);
      }
      $("body").append(div);
    }
  }

  function notInRefreshMode() {
    if (needToRefresh != false) {
      needToRefresh = false;
      settings.onRefreshChange(needToRefresh, needsGlobalRefresh, "ShouldNotRefresh");
    }
  }

  function inRefreshMode(reason) {
    if (needToRefresh != true) {
      needToRefresh = true && isInIframe();
      if (reason) {
        //we have a reason
        //maybe when reason is null in Container, the container is trying to get variables at the same time as the screen is reloading and the variables have not been set
        //check that later
      } else {
        reason = "ReasonUndefined";
      }
      settings.onRefreshChange(needToRefresh, needsGlobalRefresh, reason);
    }
  }

  function inGlobalRefreshMode(reason) {
    if (needsGlobalRefresh != true) {
      needsGlobalRefresh = true && isInIframe();
      settings.onRefreshChange(needToRefresh, needsGlobalRefresh, reason);
    }
  }

  function isInIframe() {
    if (top === self) {
      return false;
    } else {
      return true;
    }
  }

  function useDebugUpdate() {
    return settings && settings.debug && settings.debug.update;
  }

  function getInteractionElement() {
    var type = typeof settings.interactivity.primaryInteraction;
    var interactionElement = settings.interactivity.primaryInteraction;
    if (type == "string") {
      interactionElement = $(settings.interactivity.primaryInteraction);
    }
    return interactionElement;
  }

  function updateTemplates() {
    if (!inPaging && !inFreesPaging) {
      logThis2("updateTemplates");
      CheckPeriod();
      setupContent("primaryBusyTemplate", primaryItem, screenHelper.getElements(settings.elements.primary));
    }
    setupContent("secondaryTemplate", secondaryItem, screenHelper.getElements(settings.elements.secondary));
    setupContent("clockTemplate", clockItem, screenHelper.getElements(settings.elements.clock));

    setupContent("inlineListTemplate", theList, screenHelper.getElements(settings.elements.list));
    logThis("screenInfoItem");
    logThis(screenInfoItem);
    setupContent("headerTemplate", screenInfoItem, screenHelper.getElements(settings.elements.header));
    setupContent("logoTemplate", screenInfoItem, screenHelper.getElements(settings.elements.logo));
    setupContent("reportErrorButtonTemplate", defectOptions, screenHelper.getElements("#reportErrorButtonContainer"));
    setupContent("footerTemplate", screenInfoItem, screenHelper.getElements(settings.elements.footer));
    storeTemplateData("errorReportTemplate", defectOptions);
    storeTemplateData("screenInfoTemplate", screenInfoItem);
    storeTemplateData("listTemplate", theList);
    logThis("IIInteractivityItem");
    logThis(interactivityItem);

    if (interactivityItem && $("#interactivityTemplate").length > 0) {
      var interactionElement = getInteractionElement();

      interactionElement.empty();
      $("#interactivityTemplate").tmpl(interactivityItem, settings.localization).appendTo(interactionElement);
    }
    setupStockTicker();
    setupTextCut();
    setupTextResize();
    setupImageResizers();
    if (primaryItem) {
      setupStatusUpdater(primaryItem.Status);
    }
    logThis("primaryItem");
    logThis(primaryItem);
    logThis("ScreenVisibility");
    setVisibility(screenInfoItem.ScreenVisibility);
  }

  function CheckPeriod() {
    if (
      primaryItem &&
      (primaryItem.Status === "busy" || primaryItem.Status === "UnavailableNow") &&
      secondaryItem.OriginalPeriod
    ) {
      secondaryItem.Period = secondaryItem.OriginalPeriod;
    }
  }

  function setVisibility(screenVisibility) {
    if (!screenVisibility) {
      return;
    }
    if (!screenVisibility.ShowMeetinglistButton) {
      var listTrigger = $(settings.interactivity.listTrigger);
      if (listTrigger.length > 0) {
        listTrigger.hide();
      }
    }
  }

  function setupStatusUpdater(status) {
    var statusUpdater = screenHelper.getElements(settings.elements.statusUpdater);
    if (statusUpdater && statusUpdater.length > 0) {
      statusUpdater.each(function () {
        setStatusClass($(this), status);
      });
    }
  }

  function setStatusClass(el, status) {
    removeStatusClass(el);
    el.addClass(status);
  }

  function removeStatusClass(el) {
    $.each(statusArray, function (value) {
      el.removeClass(value);
    });
  }

  function setupImageResizers() {
    var imageResizers = screenHelper.getElements(settings.elements.imageResizers);
    logThis("imageResizers");
    logThis(imageResizers);

    if (imageResizers.length > 0) {
      imageResizers.each(function () {
        $(this)
          .find("img")
          .map(function () {
            $(this).fitimage();
          });
      });
    }
  }

  function setupTextResize() {
    logThis("settings.elements.textResize:" + settings.elements.textResize);
    var textResize = screenHelper.getElements(settings.elements.textResize);
    if (textResize.length > 0) {
      textResize.each(function () {
        setHeaderTextFitting($(this));
      });
    }
  }
  function setupTextCut() {
    var textCut = screenHelper.getElements(settings.elements.textCut);
    if (textCut.length > 0) {
      textCut.each(function () {
        createTextCut($(this));
      });
    }
  }

  function getProperty(el, prop) {
    var property = el.css(prop);
    if (!property) {
      if (el.parent()) {
        return getProperty(el.parent(), prop);
      } else {
        return null;
      }
    }
    return property;
  }

  function setHeaderTextFitting(el) {
    var originalFontSizeText = getProperty(el, "font-size");
    var originalFontSize = 20;
    if (originalFontSizeText) {
      originalFontSize = originalFontSizeText.replace("px", "");
    }
    var sectionWidth = el.parent().width();

    var spanWidth = el.width();
    var newFontSize = (sectionWidth / spanWidth) * originalFontSize;
    el.css({ "font-size": newFontSize, "line-height": newFontSize / 1.2 + "px" });
  }

  function createTextCut(testelement) {
    logThis("try textcut on " + testelement.attr("class") + "#" + testelement.attr("id"));

    var el = testelement;
    el.css("white-space", "nowrap");
    el.css("overflow", "hidden");
    el.css("text-overflow", "ellipsis");
  }
  function setupStockTicker() {
    var stockTickers = screenHelper.getElements(settings.elements.stockTickers);
    if (stockTickers.length > 0) {
      stockTickers.each(function () {
        finalStock($(this));
      });
    }
  }
  function finalStock(originalElement) {
    logThis("test stockwidth:-" + originalElement.width());
    logThis("try stockticker on " + originalElement.attr("class") + "#" + originalElement.attr("id"));
    var originalWhiteSpace = originalElement.css("white-space");
    var originalElementHtml = originalElement.html();
    var originalElementHtmlTrimmed = $.trim(originalElementHtml);
    originalElementHtml = originalElementHtmlTrimmed;
    if (originalElementHtml.length == 0) {
      return;
    }
    var scrollTestElement = $('<div style="width:auto;overflow:hidden;" />');
    scrollTestElement.append(originalElementHtml);

    originalElement.css("white-space", "nowrap");
    originalElement.html(scrollTestElement);

    logThis(
      "test stockwidth:" +
        scrollTestElement.get(0).scrollWidth +
        "==" +
        scrollTestElement.width() +
        " for [" +
        originalElementHtml +
        "]"
    );
    if (scrollTestElement.get(0).scrollWidth == scrollTestElement.width()) {
      logThis("no setup stockticker for1:" + originalElementHtml);
      return;
    } else if (scrollTestElement.get(0).scrollWidth < scrollTestElement.width()) {
      logThis("no setup stockticker for2:" + originalElementHtml);
      originalElement.html(originalElementHtml);
      originalElement.css("white-space", originalWhiteSpace);
      return;
    }
    logThis("originalElement:" + originalElement.attr("class"));
    var el = originalElement;
    var height = getPossibleHeight(el);
    screenHelper.logThis("height:" + height);
    var content = el.html();

    var rand = getRandomId();

    var scroller = $("<div></div>");
    scroller.css("position", "relative");
    scroller.css("overflow", "hidden");
    scroller.css("text-align", "right");

    var scrollerText = $('<div id="stockticker' + rand + '"></div>');
    scrollerText.css("position", "absolute");
    scrollerText.css("white-space", "nowrap");
    scrollerText.css("overflow", "hidden");

    scroller.append(scrollerText);
    scrollerText.append(content);
    scroller.css("height", height + "px");

    el.html(scroller);
    logThis("setup stockticker for:" + originalElementHtml);

    var totalPages = Math.ceil(total / max);
    var maxTime = settings.update.interval * 1000;
    if (totalPages > 1) {
      maxTime = settings.paging.interval;
    }
    logThis("maxTime:" + maxTime);
    scrollerText.stockticker({ totaltime: maxTime });
  }

  function getRandomId() {
    return Math.floor(Math.random() * 22);
  }

  function getPossibleHeight(el) {
    var height = el.height();

    if (height && height > 0) {
    } else {
      var line = el.css("line-height");
      screenHelper.logThis("line:" + line);
      var font = el.css("font-size");
      screenHelper.logThis("font:" + font);
      if (line.indexOf("px") != -1) {
        height = parseFloat(line.substring(0, line.indexOf("px")));
        height = height;
      } else if (font.indexOf("px") != -1) {
        height = parseFloat(font.substring(0, font.indexOf("px")));
        height = height + height / 2;
      } else {
        height = 25;
      }
    }
    return height;
  }

  function isInRefreshMode() {
    return needToRefresh || needsGlobalRefresh;
  }

  function storeTemplateData(templateId, data) {
    $.data(document.body, templateId, data);
  }

  function setupContent(templateId, item, container, useHandlebars) {
    debugLog("setupContent:" + templateId);

    var contentUpdated = "";
    if (useDebugUpdate()) {
      if (container && container.length > 0) {
        contentUpdated = container.html();
      }
    }
    var template = $("#" + templateId);
    if (item && template.length > 0) {
      screenTemplate.update(template, item, container, settings.localization, useHandlebars);
      if (container) {
        logThis(item);
        container.data("itemData", item);
      }
    }
    if (useDebugUpdate()) {
      if (container && container.length > 0) {
        if (contentUpdated != container.html()) {
          debugLog("&nbsp;&nbsp;&nbsp;updated with new content " + templateId);
        } else {
          debugLog("&nbsp;&nbsp;&nbsp;no content update for " + templateId, false);
        }
      }
    }
  }
  function debugLog(txt, good) {
    if (!useDebugUpdate()) {
      return;
    }
    var branding = $("#proNestorDisplayDebugLog");
    if (branding.length == 0) {
      var errorWrapper = $(
        '<div id="DebugWrapper" style="color:black;background-color:red">Debug window (envoked by double click)<br/></div>'
      );
      var errorPanelReload = $(
        '<a id="DebugPanelReload" href="#" style="color:black;position:absolute;top:0">Reload(lastReload:' +
          new Date() +
          ")</a>"
      );

      branding = $(
        '<div id="proNestorDisplayDebugLog" style="width:600px;height:600px;color:black;background-color:transparent;padding-top:20px"></div>'
      );
      branding.append(errorPanelReload);
      errorWrapper.append(branding);
      $("body").append(errorWrapper);
      errorWrapper.hide();
      $("#DebugPanelReload").live("click", function () {
        displayReload.doReload("DebugLogForced");
      });
    }
    var output = '<span style="color:green;">' + txt + "</span>";
    if (good !== null && good == false) {
      output = '<span style="color:red;">' + txt + "</span>";
    }
    branding.html(output + "<br/>" + branding.html());

    limitDebugLog(branding);
  }

  function limitDebugLog(branding) {
    var maxDebugLog = 10 * 60;
    if (settings.debug && settings.debug.maxDebugLog) {
      maxDebugLog = settings.debug.maxDebugLog;
    }
    var dd = branding.html();
    var splited = dd.split('<div class="no-class"></div>');
    if (splited.length > maxDebugLog) {
      var newstuff = dd.replace(splited[splited.length - 2] + '<div class="no-class"></div>', "");
      branding.html(newstuff);
    }
  }

  function logThis(txt) {
    screenHelper.logThis(txt, this);
  }

  function logThis2(txt) {
    screenHelper.logThis2(txt, this);
  }
}
