﻿function ScreenSettings() {
  this.storeSettings = function (primaryElement, options) {
    primaryElement = $("body");
    var settings = $.extend(
      true,
      {
        useEventModels: true,
        endTimeElementId: "bookRoomTime",
        endTimeSpanId: "bookRoomTimeSpan",
        endTimeRescheduleSpanId: "endTimeRescheduleSpan",
        durationSpanId: "meetingDuration",
        durationRescheduleSpanId: "rescheduledMeetingDuration",
        elements: {
          primary: "#primary",
          secondary: "#secondary",
          clock: "#clock",
          footer: "#footer",
          logo: "#logo",
          list: "#list",
          header: "#header",
          stockTickers: null,
          imageResizers: null,
          statusUpdater: null,
          textResizeOffset: -150,
        },
        defect: {
          reportDefectPath: null,
          clearDefectPath: null,
        },
        update: {
          updatePath: null,
          interval: 60,
          pager: null,
        },
        paging: null,
        interactivity: {
          primaryInteraction: "#primaryInteraction",
          commandPath: null,
          aboutTrigger: ".aboutBtn",
          maxIdle: 20,
          preparationTime: 15,
          minimumBookTime: null /*should follow preparationTime*/,
          screenId: null,
          areaInteractTrigger: "areaInt",
          BookingEnabled: false,
          ConfirmationEnabled: false,
          ReschedulingEnabled: false,
          ConfirmationInAdvanceLimit: 0,
          ConfirmationDeadlineLimit: 0,
          confirmationBlink: true,
          lockedMeetingElement: null,
          disableOnPost: null,
          onTouchEnable: {
            elements: null,
            focusedElements: null,
            hideTimeout: 5000,
            trigger:
              ".primary-inner" /*added for backward compatability for nestor auto, when idletimer was removed for ontouchenable*/,
          },
          loadingBehaviour: {
            showLoading: true,
            startAfter: 1000,
            endAfter: 8000,
            minShowTime: 2000,
            position: "center", //or class
            topPosition: "400px",
          },
          dialogBehaviour: {
            transitionIn: "fade",
            transitionOut: "fade",
            speedIn: 1,
            speedOut: 1,
          },
          defaultDuration: 60,
        },
        localization: null,
        onRefreshChange: function () {},
        onScreenNotFound: function () {},
        onAjaxError: function () {},
        on500Threshold: function () {},
        onAjaxRecover: function () {},
        demo: null,
        onUpdate: function (screenData) {
          // logThis(primaryElement.attr('id') + ':' + 'updateDone');
          primaryElement.trigger("updateDone", [screenData]);
        },
        interactionDone: function () {
          primaryElement.trigger("update");
          $(document).trigger("screenDisplay:interactivity");
        },
        areaInteractionStarted: function () {
          //  logThis('freezePaging attempt');
          primaryElement.trigger("freezePaging");
        },
        onIdle: function () {
          $.fancybox.close();
        },
        debug: {
          update: false,
          maxDebugLog: 60,
          showFetchTimestamp: false,
          showUpdatedTimestamp: false,
        },
        refresh: null,
        activityIndication: false,
        interactionIndication: false,
        external: {
          id: null,
          siteUrl: null,
          siteHeight: null,
          scroll: false,
          refresh: false,
          style: "width:100%;position:absolute;bottom:0;text-align:center;", //add ;text-align:center; for image urls
        },
        inject: null,
      },
      options
    );

    $.data(document.body, "screenSettings", settings);
  };

  this.settings = function () {
    var data = $.data(document.body, "screenSettings");
    return data;
  };

  return this;
}
