﻿(function ($) {
  $.fn.stockticker = function (options) {
    var settings = $.extend(
      {
        speed: 10,
        pause: 3000,
        scrollback: false,
        runonce: true,
        totaltime: 60000,
        debug: false,
      },
      options
    );

    var speed = settings.speed;
    var pause = settings.pause;
    var scrollback = settings.scrollback;
    var runonce = settings.runonce;
    var totaltime = settings.totaltime - 5000;

    this.each(function () {
      var ob = $(this);
      var len = ob.get(0).offsetWidth - ob.parent().width();
      len = len * -1;
      if (ob.width() > ob.parent().width()) {
        ob.css("right", len);

        ob.append($('<div style="display:none;" id="' + $(ob).attr("id") + '_right" >' + len + "</div>"));
        ob.append($('<div style="display:none;" id="' + $(ob).attr("id") + '_runonce" >' + runonce + "</div>"));
        ob.append(
          $(
            '<div style="display:none;" id="' +
              $(ob).attr("id") +
              '_start" >' +
              getStringFromDate(new Date()) +
              "</div>"
          )
        );
        ob.append($('<div style="display:none;" id="' + $(ob).attr("id") + '_total" >' + totaltime + "</div>"));
        ob.addClass("inanimation");
        resetElement(ob, "0");
      } else {
        ob.parent().width(ob.width());
      }
    });

    function resetElement(ob, to) {
      var id = $(ob).attr("id");
      AddDebugInfo("start on " + id);
      var int_to = parseInt(to);
      var f = function () {
        animateScroll(id, int_to);
      };
      setTimeout(f, pause);
    }

    function resetElement2(ob, to) {
      var id = $(ob).attr("id");
      AddDebugInfo("pause on " + id);
      var int_to = parseInt(to);
      var f = function () {
        animateBackTo(id, int_to);
      };
      setTimeout(f, pause);
    }

    function stopAnimation(id, to) {
      AddDebugInfo("stop on " + id);
      var ob = $("#" + id);
      ob.animate({ right: to }, getBackSpeedFromString(ob.width()), "linear");
    }

    function animateBackTo(id, to) {
      AddDebugInfo("back on " + id);
      var ob = $("#" + id);
      ob.animate({ right: to }, getBackSpeedFromString(ob.width()), "linear", function () {
        if (HasMoreTime(this)) {
          resetElement(this, "0");
        } else {
          stopAnimation(this.id, $("#" + this.id + "_right").html());
        }
      });
    }
    function HasMoreTime(ob) {
      var el = $("#" + ob.id + "_total").html();
      var totaltime = parseInt(el);
      var elapsed_now = new Date().getTime() - getDateFromString($("#" + ob.id + "_start").html()).getTime();
      var left = totaltime - elapsed_now;
      if (elapsed_now < left) {
        $("#" + ob.id + "_total").html(left);
        $("#" + ob.id + "_start").html(getStringFromDate(new Date()));
        return true;
      } else {
        return false;
      }
    }

    function getDateFromString(str) {
      var year = 0;
      var month = 1;
      var date = 2;
      var hour = 3;
      var minute = 4;
      var second = 5;
      var millisecond = 6;
      var items = str.split("-");

      year = parseInt(items[year]);
      month = parseInt(items[month]);
      date = parseInt(items[date]);
      hour = parseInt(items[hour]);
      minute = parseInt(items[minute]);
      second = parseInt(items[second]);
      millisecond = parseInt(items[millisecond]);

      return new Date(year, month, date, hour, minute, second, millisecond);
    }
    function getStringFromDate(date) {
      var str = "";
      str += date.getFullYear() + "-";
      str += date.getMonth() + "-";
      str += date.getDate() + "-";
      str += date.getHours() + "-";
      str += date.getMinutes() + "-";
      str += date.getSeconds() + "-";
      str += date.getMilliseconds();

      return str;
    }

    function animateScroll(id, to) {
      var ob = $("#" + id);
      ob.animate({ right: to }, getSpeedFromString(ob.width()), "linear", function () {
        resetElement2(this, $("#" + this.id + "_right").html());
      });
    }

    function getBackSpeedFromString(width) {
      if (scrollback) {
        return width * speed;
      } else {
        return 0;
      }
    }

    function getSpeedFromString(width) {
      return width * speed;
    }

    function AddDebugInfo(info, truncate) {
      if (settings.debug == false) {
        return;
      }

      if ($("#debugmsg").length == 0) {
        $("body").prepend($('<input id=debugmsg type=text style="width:600px" value=debugin />'));
      }

      if (truncate) {
        $("#debugmsg").val("");
      }
      $("#debugmsg").val($("#debugmsg").val() + " | " + info);
    }

    return this;
  };

  $.fn.stopstockticker = function (options) {
    $(".scrollingtext").each(function () {
      if (this.width() > this.parent().width()) {
        this.stop(true);
        this.animate({ right: $("#" + this.id + "_right").html() }, 1, "linear", function () {});
      }
    });
    return this;
  };
})(jQuery);
