﻿function TimeUtility() {
  var dan = {
    Sun: "Sø",
    Mon: "Ma",
    Tue: "Ti",
    Wed: "On",
    Thu: "To",
    Fri: "Fr",
    Sat: "Lø",
    Sunday: "Søndag",
    Monday: "Mandag",
    Tuesday: "Tirsdag",
    Wednesday: "Onsdag",
    Thursday: "Torsdag",
    Friday: "Fredag",
    Saturday: "Lørdag",
    Jan: "Jan",
    Feb: "Feb",
    Mar: "Mar",
    Apr: "Apr",
    May: "Maj",
    Jun: "Jun",
    Jul: "Jul",
    Aug: "Aug",
    Sep: "Sep",
    Oct: "Okt",
    Nov: "Nov",
    Dec: "Dec",
    January: "Januar",
    February: "Februar",
    March: "Marts",
    April: "April",
    MayFull: "Maj",
    June: "Juni",
    July: "Juli",
    August: "August",
    September: "September",
    October: "Oktober",
    November: "November",
    December: "December",
  };

  var no = {
    Sun: "Sø",
    Mon: "Ma",
    Tue: "Ti",
    Wed: "On",
    Thu: "To",
    Fri: "Fr",
    Sat: "Lø",
    Sunday: "Søndag",
    Monday: "Mandag",
    Tuesday: "Tirsdag",
    Wednesday: "Onsdag",
    Thursday: "Torsdag",
    Friday: "Fredag",
    Saturday: "Lørdag",
    Jan: "Jan",
    Feb: "Feb",
    Mar: "Mar",
    Apr: "Apr",
    May: "Mai",
    Jun: "Jun",
    Jul: "Jul",
    Aug: "Aug",
    Sep: "Sep",
    Oct: "Okt",
    Nov: "Nov",
    Dec: "Des",
    January: "Januar",
    February: "Februar",
    March: "Mars",
    April: "April",
    MayFull: "Mai",
    June: "Juni",
    July: "Juli",
    August: "August",
    September: "September",
    October: "Oktober",
    November: "November",
    December: "Desember",
  };

  var se = {
    Sun: "Sö",
    Mon: "Må",
    Tue: "Ti",
    Wed: "On",
    Thu: "To",
    Fri: "Fr",
    Sat: "Lö",
    Sunday: "Söndag",
    Monday: "Måndag",
    Tuesday: "Tirsdag",
    Wednesday: "Onsdag",
    Thursday: "Torsdag",
    Friday: "Fredag",
    Saturday: "Lördag",
    Jan: "Jan",
    Feb: "Feb",
    Mar: "Mar",
    Apr: "Apr",
    May: "Maj",
    Jun: "Jun",
    Jul: "Jul",
    Aug: "Aug",
    Sep: "Sep",
    Oct: "Okt",
    Nov: "Nov",
    Dec: "Dec",
    January: "Januari",
    February: "Februari",
    March: "Mars",
    April: "April",
    MayFull: "Maj",
    June: "Juni",
    July: "Juli",
    August: "Augusti",
    September: "September",
    October: "Oktober",
    November: "November",
    December: "December",
  };

  function getLanguage(languageCode) {
    var type = typeof languageCode;

    if (type == "string") {
      return getLanguageFromCode(languageCode);
    } else {
      return getLanguageObject(languageCode);
    }
  }

  function getLanguageObject(languageObject) {
    if (languageObject) {
      return {
        Sun: languageObject.Sun,
        Mon: languageObject.Mon,
        Tue: languageObject.Tue,
        Wed: languageObject.Wed,
        Thu: languageObject.Thu,
        Fri: languageObject.Fri,
        Sat: languageObject.Sat,
        Sunday: languageObject.Sunday,
        Monday: languageObject.Monday,
        Tuesday: languageObject.Tuesday,
        Wednesday: languageObject.Wednesday,
        Thursday: languageObject.Thursday,
        Friday: languageObject.Friday,
        Saturday: languageObject.Saturday,
        Jan: languageObject.Jan,
        Feb: languageObject.Feb,
        Mar: languageObject.Mar,
        Apr: languageObject.Apr,
        May: languageObject.May,
        Jun: languageObject.Jun,
        Jul: languageObject.Jul,
        Aug: languageObject.Aug,
        Sep: languageObject.Sep,
        Oct: languageObject.Oct,
        Nov: languageObject.Nov,
        Dec: languageObject.Dec,
        January: languageObject.January,
        February: languageObject.February,
        March: languageObject.March,
        April: languageObject.April,
        June: languageObject.June,
        July: languageObject.July,
        August: languageObject.August,
        September: languageObject.September,
        October: languageObject.October,
        November: languageObject.November,
        December: languageObject.December,
      };
    }
    return null;
  }

  function getLanguageFromCode(languageCode) {
    if (languageCode == "da-DK") {
      return dan;
    }
    if (languageCode == "nb-NO") {
      return no;
    }
    if (languageCode == "sv-SE") {
      return se;
    }

    return null;
  }

  function replaceFormat(sFormat, par1, par2) {
    return sFormat.replace(par1, par2);
  }

  function getProperty(dateObject, property) {
    switch (property) {
      case "a": // abbrv day names
        return daysAbbrvNames[dateObject.getDay()];
      case "A": // full day names
        return daysFullNames[dateObject.getDay()];
      case "b": // abbrv month names
        return monthsAbbrvNames[dateObject.getMonth()];
      case "B": // full month names
        return monthsFullNames[dateObject.getMonth()];
      case "d": // day 01-31
        return (dateObject.getDate() < 10 ? "0" : "") + dateObject.getDate();
      case "H": // hour as a decimal number using a 24-hour clock (range 00 to 23)
        return (dateObject.getHours() < 10 ? "0" : "") + dateObject.getHours();
      case "I": // hour as a decimal number using a 12-hour clock (range 01 to 12)
        var hours = dateObject.getHours() % 12 || 12;
        return (hours < 10 ? "0" : "") + hours;
      case "i": // hour as a decimal number using a 12-hour clock (range 01 to 12)
        var hours = dateObject.getHours() % 12 || 12;
        return hours;
      case "m": // month number
        return (dateObject.getMonth() < 9 ? "0" : "") + (dateObject.getMonth() + 1);
      case "M": // minute as a decimal number
        return (dateObject.getMinutes() < 10 ? "0" : "") + dateObject.getMinutes();
      case "p": // either `am' or `pm' according to the given time value,
        // or the corresponding strings for the current locale
        return dateObject.getHours() < 12 ? "am" : "pm";
      case "P": // either `AM' or `PM' according to the given time value,
        return dateObject.getHours() < 12 ? "AM" : "PM";
      case "S": // second as a decimal number
        return (dateObject.getSeconds() < 10 ? "0" : "") + dateObject.getSeconds();
      case "y": // two-digit year
        return dateObject.getFullYear().toString().substring(2);
      case "Y": // full year
        return dateObject.getFullYear();
      case "%":
        return "%";
    }
  }

  this.getDiffMinutes = function (date1, date2) {
    var diffMs = date2 - date1; // milliseconds between now & Christmas
    var sec = diffMs * 0.001;
    var min = sec / 60;
    return Math.floor(min);
    var diffDays = Math.round(diffMs / 86400000); // days
    var diffHrs = Math.round((diffMs % 86400000) / 3600000); // hours
    var diffMins = Math.round(((diffMs % 86400000) % 3600000) / 60000); // minutes
    console.log("getDiffMinutes:" + date1 + ":" + date2);
    console.log("getDiffMinutes:" + diffHrs + ":" + diffMins);
    return diffDays * 24 * 60 + diffHrs * 60 + diffMins;
  };
  this.getHoursAndMinutesBetweenDates = function (date1, date2) {
    var diffHrs = this.dateDiff("h", date1, date2);
    var diffMins = this.dateDiff("n", date1, date2);
    while (diffMins > 59) {
      diffMins = diffMins - 60;
    }
    return diffHrs + ":" + diffMins;
  };
  // datepart: 'y', 'm', 'w', 'd', 'h', 'n', 's'
  this.dateDiff = function (datepart, fromdate, todate) {
    datepart = datepart.toLowerCase();
    var diff = todate - fromdate;
    var divideBy = {
      w: 604800000,
      d: 86400000,
      h: 3600000,
      n: 60000,
      s: 1000,
    };

    return Math.floor(diff / divideBy[datepart]);
  };

  this.cloneDate = function (date) {
    return new Date(date.getTime());
  };
  this.createTime = function (time) {
    return new Date(time.Year, time.Month - 1, time.Day, time.Hour, time.Minute, time.Second, time.Millisecond);
  };
  this.getEndOfDay = function (date) {
    var current = this.cloneDate(date);
    current.setHours(23, 59, 59, 999);
    return current;
  };
  this.addSecondsToTime = function (dateObject, seconds) {
    return new Date(dateObject.getTime() + seconds * 1000);
  };
  this.addToTime = function (dateObject, minutes) {
    return new Date(dateObject.getTime() + minutes * 60000);
  };

  this.formatTime = function (sFormat, dateObject, language) {
    // %a
    daysAbbrvNames = new Array(7);
    daysAbbrvNames[0] = "Sun";
    daysAbbrvNames[1] = "Mon";
    daysAbbrvNames[2] = "Tue";
    daysAbbrvNames[3] = "Wed";
    daysAbbrvNames[4] = "Thu";
    daysAbbrvNames[5] = "Fri";
    daysAbbrvNames[6] = "Sat";

    // %A
    daysFullNames = new Array(7);
    daysFullNames[0] = "Sunday";
    daysFullNames[1] = "Monday";
    daysFullNames[2] = "Tuesday";
    daysFullNames[3] = "Wednesday";
    daysFullNames[4] = "Thursday";
    daysFullNames[5] = "Friday";
    daysFullNames[6] = "Saturday";

    // %b
    monthsAbbrvNames = new Array(12);
    monthsAbbrvNames[0] = "Jan";
    monthsAbbrvNames[1] = "Feb";
    monthsAbbrvNames[2] = "Mar";
    monthsAbbrvNames[3] = "Apr";
    monthsAbbrvNames[4] = "May";
    monthsAbbrvNames[5] = "Jun";
    monthsAbbrvNames[6] = "Jul";
    monthsAbbrvNames[7] = "Aug";
    monthsAbbrvNames[8] = "Sep";
    monthsAbbrvNames[9] = "Oct";
    monthsAbbrvNames[10] = "Nov";
    monthsAbbrvNames[11] = "Dec";

    // %B
    monthsFullNames = new Array(12);
    monthsFullNames[0] = "January";
    monthsFullNames[1] = "February";
    monthsFullNames[2] = "March";
    monthsFullNames[3] = "April";
    monthsFullNames[4] = "May";
    monthsFullNames[5] = "June";
    monthsFullNames[6] = "July";
    monthsFullNames[7] = "August";
    monthsFullNames[8] = "September";
    monthsFullNames[9] = "October";
    monthsFullNames[10] = "November";
    monthsFullNames[11] = "December";

    var languageArr = getLanguage(language);
    if (languageArr) {
      daysAbbrvNames[0] = languageArr.Sun;
      daysAbbrvNames[1] = languageArr.Mon;
      daysAbbrvNames[2] = languageArr.Tue;
      daysAbbrvNames[3] = languageArr.Wed;
      daysAbbrvNames[4] = languageArr.Thu;
      daysAbbrvNames[5] = languageArr.Fri;
      daysAbbrvNames[6] = languageArr.Sat;

      // %A
      daysFullNames[0] = languageArr.Sunday;
      daysFullNames[1] = languageArr.Monday;
      daysFullNames[2] = languageArr.Tuesday;
      daysFullNames[3] = languageArr.Wednesday;
      daysFullNames[4] = languageArr.Thursday;
      daysFullNames[5] = languageArr.Friday;
      daysFullNames[6] = languageArr.Saturday;

      // %b
      monthsAbbrvNames[0] = languageArr.Jan;
      monthsAbbrvNames[1] = languageArr.Feb;
      monthsAbbrvNames[2] = languageArr.Mar;
      monthsAbbrvNames[3] = languageArr.Apr;
      monthsAbbrvNames[4] = languageArr.May;
      monthsAbbrvNames[5] = languageArr.Jun;
      monthsAbbrvNames[6] = languageArr.Jul;
      monthsAbbrvNames[7] = languageArr.Aug;
      monthsAbbrvNames[8] = languageArr.Sep;
      monthsAbbrvNames[9] = languageArr.Oct;
      monthsAbbrvNames[10] = languageArr.Nov;
      monthsAbbrvNames[11] = languageArr.Dec;

      // %B
      monthsFullNames[0] = languageArr.January;
      monthsFullNames[1] = languageArr.February;
      monthsFullNames[2] = languageArr.March;
      monthsFullNames[3] = languageArr.April;
      monthsFullNames[4] = languageArr.May;
      monthsFullNames[5] = languageArr.June;
      monthsFullNames[6] = languageArr.July;
      monthsFullNames[7] = languageArr.August;
      monthsFullNames[8] = languageArr.September;
      monthsFullNames[9] = languageArr.October;
      monthsFullNames[10] = languageArr.November;
      monthsFullNames[11] = languageArr.December;
    }

    var timeNow = "";
    var i = 0;
    var index = 0;
    while ((index = sFormat.indexOf("%", i)) != -1) {
      timeNow += sFormat.substring(i, index);
      index++;

      var property = getProperty(dateObject, sFormat.charAt(index));
      index++;

      timeNow += property;
      i = index;
    }

    timeNow += sFormat.substring(i);
    return timeNow;
  };

  this.convertFromDotNet = function (sFormat, amDesignator) {
    var ttValue = "%P";
    /*  if (amDesignator) {
            if (amDesignator == "AM") {
                ttValue = "%P";
            }
        }*/
    var sWhat = sFormat;
    var previous;
    sWhat = replaceFormat(sWhat, "yyyy", "%Y");
    sWhat = replaceFormat(sWhat, "yy", "%y");
    previous = sWhat;
    sWhat = replaceFormat(sWhat, "MMMM", "%b");
    if (previous === sWhat) {
      sWhat = replaceFormat(sWhat, "MM", "%m");
    }
    if (previous === sWhat) {
      sWhat = replaceFormat(sWhat, "M", "%m");
    }

    sWhat = replaceFormat(sWhat, "dddd", "%a");

    sWhat = replaceFormat(sWhat, "ddd", "%a");

    previous = sWhat;
    sWhat = replaceFormat(sWhat, "dd", "%d");

    if (previous === sWhat) {
      sWhat = replaceFormat(sWhat, "d", "%d");
    }
    sWhat = replaceFormat(sWhat, "HH", "%H");

    if (previous === sWhat) {
      sWhat = replaceFormat(sWhat, "H", "%H");
    }
    sWhat = replaceFormat(sWhat, "hh", "%I");

    sWhat = replaceFormat(sWhat, "h", "%i");

    sWhat = replaceFormat(sWhat, "mm", "%M");
    sWhat = replaceFormat(sWhat, "ss", "%S");
    sWhat = replaceFormat(sWhat, "tt", ttValue);
    return sWhat;
  };

  return this;
}
