﻿function ScreenApiEventModel() {
  this.convertEventDates = function (data) {
    if (data.Events) {
      $.each(data.Events, function (i, item) {
        if (item.Period) {
          item.Period.Start = moment.utc(item.Period.Start).toDate();
          item.Period.End = moment.utc(item.Period.End).toDate();
        }
        if (item.ReservationPeriod) {
          item.ReservationPeriod.Start = moment.utc(item.ReservationPeriod.Start).toDate();
          item.ReservationPeriod.End = moment.utc(item.ReservationPeriod.End).toDate();
        }

        if (item.EffectiveReservationPeriod) {
          item.EffectiveReservationPeriod.Start = moment.utc(item.EffectiveReservationPeriod.Start).toDate();
          item.EffectiveReservationPeriod.End = moment.utc(item.EffectiveReservationPeriod.End).toDate();
        }

        if (item.AlternateReservationPeriod) {
          item.AlternateReservationPeriod.Start = moment.utc(item.AlternateReservationPeriod.Start).toDate();
          item.AlternateReservationPeriod.End = moment.utc(item.AlternateReservationPeriod.End).toDate();
        }
      });
    }

    $.each(data.Items, function (i, item) {
      if (item.PeriodDateTimeRange) {
        var start = new Date(Date.parse(item.PeriodDateTimeRange.Start));
        var end = new Date(Date.parse(item.PeriodDateTimeRange.End));
        item.PeriodDateTimeRange.Start = toScreenTime(start, item.TimezoneOffset);
        item.PeriodDateTimeRange.End = toScreenTime(end, item.TimezoneOffset);
      }
    });
    return data;
  };

  function toScreenTime(targetTime, timezoneOffset) {
    var timeZoneFromDB = convertTimezoneOffsetToDecimal(timezoneOffset);
    var tzDifference = timeZoneFromDB * 60 + targetTime.getTimezoneOffset();
    var offsetTime = new Date(targetTime.getTime() + tzDifference * 60 * 1000);
    return offsetTime;
  }
  function convertTimezoneOffsetToDecimal(timezoneOffset) {
    var splitted = timezoneOffset.split(":");
    var min = 0;
    if (splitted.length > 1) {
      min = parseInt(splitted[1]);
      if (min > 0) {
        min = 5;
      }
    }
    return parseFloat(splitted[0] + "." + min);
  }

  this.transformEventModelToDisplayItem = function (eventModel) {};
}
