﻿function ScreenApiInteractivity(options) {
  var settings = $.extend({}, options);

  setup();

  function setup() {
    if (!PRONESTORDISPLAY.events) {
      PRONESTORDISPLAY.events = {};
    }
    if (!PRONESTORDISPLAY.events.bookAttached) {
      if (settings.book) {
        if (settings.book.show) {
          setupBook();
        }
      }
      PRONESTORDISPLAY.events.bookAttached = true;
    }

    if (!PRONESTORDISPLAY.events.rescheduleAttached) {
      if (settings.reschedule) {
        if (settings.reschedule.show) {
          setupReschedule();
        }
      }
      PRONESTORDISPLAY.events.rescheduleAttached = true;
    }

    if (!PRONESTORDISPLAY.events.endAttached) {
      if (settings.end) {
        if (settings.end.show) {
          setupEnd();
        }
      }
      PRONESTORDISPLAY.events.endAttached = true;
    }

    if (!PRONESTORDISPLAY.events.idleAttached) {
      $(document).on("hideInteractivity", function (e) {
        settings.book.hide();
        settings.reschedule.hide();
      });
      PRONESTORDISPLAY.events.idleAttached = true;
    }
  }

  function setupEnd() {
    settings.end.trigger = "click";

    if (settings.end.commit) {
      $(document).on(settings.end.trigger, settings.end.commit.selector, function (e) {
        settings.end.commit.action();
      });
    }
    $(document).on(settings.end.trigger, settings.end.selector, function (e) {
      var _this = $(this);
      //before this event
      if (settings.end.onBeforeShow) {
        settings.end.onBeforeShow(e, _this);
      }

      //if show hide elements
      if ($(settings.end.selector).data("visible")) {
        $(settings.end.selector).data("visible", false);
        settings.end.hide(_this, e);
      } else {
        ScreenModule.pincode.addPincodeWatch(
          function (accepted) {
            if (accepted) {
              $(settings.end.selector).data("visible", true);
              settings.end.show(_this, e);
            }
          },
          settings.end.noPincode,
          settings.confirm
        );
      }
    });
  }

  function setupReschedule() {
    settings.reschedule.trigger = "click";

    if (settings.reschedule.commit) {
      $(document).on(settings.reschedule.trigger, settings.reschedule.commit.selector, function (e) {
        settings.reschedule.commit.action();
      });
    }
    $(document).on(settings.reschedule.trigger, settings.reschedule.selector, function (e) {
      var _this = $(this);
      //before this event
      if (settings.reschedule.onBeforeShow) {
        settings.reschedule.onBeforeShow(e, _this);
      }

      //if show hide elements
      if ($(settings.reschedule.selector).data("visible")) {
        $(settings.reschedule.selector).data("visible", false);
        settings.reschedule.hide(_this, e);
      } else {
        ScreenModule.pincode.addPincodeWatch(
          function (accepted) {
            if (accepted) {
              $(settings.reschedule.selector).data("visible", true);
              settings.reschedule.show(_this, e);
            }
          },
          settings.reschedule.noPincode,
          settings.confirm
        );
      }
    });
  }

  function setupBook() {
    settings.book.trigger = "click";

    if (settings.book.commit) {
      $(document).on(settings.book.trigger, settings.book.commit.selector, function (e) {
        settings.book.commit.action();
      });
    }
    $(document).on(settings.book.trigger, settings.book.selector, function (e) {
      var _this = $(this);
      //before this event
      if (settings.book.onBeforeShow) {
        settings.book.onBeforeShow(e, _this);
      }

      //directAction
      /*   if (options.action) {
                ScreenModule.pincode.addPincodeWatch(function (accepted) {
                    if (accepted) {
                        settings.book.show.action(_this, e);
                    }
                }, settings.book.show.noPincode, settings.book.show.confirm);

                return;
            }*/

      //if show hide elements
      if ($(settings.book.selector).data("visible")) {
        $(settings.book.selector).data("visible", false);
        settings.book.hide(_this, e);
      } else {
        ScreenModule.pincode.addPincodeWatch(
          function (accepted) {
            if (accepted) {
              $(settings.book.selector).data("visible", true);
              settings.book.show(_this, e);
              //settings.book.onShow(_this, e);
            }
          },
          settings.book.noPincode,
          settings.confirm
        );
      }
    });

    /* if (hasOnTouchEvent()) {
            $(document).on(settings.book.show.trigger, settings.book.show.selector, function (e) {
                e.preventDefault();
            });
        }*/

    /*  $(settings.book.show.selector).on("click", function () {
            settings.book.show.action();
        });*/
  }

  function hasOnTouchEvent() {
    return "ontouchstart" in document.documentElement;
  }
  this.hide = function () {
    settings.book.hide();
  };
}
