var widgetAPI = new Common.API.Widget();
var tvKey = new Common.API.TVKeyValue();
var Main =
{
  networkPlugin: null,
  pluginRBTSef: null,
  _localFileSystem: null,
  _dataFileCommonPath: widget.id + '/dataFile.json'
};

Main.onLoad = function () {
  Main._localFileSystem = new FileSystem();

  Main.pluginRBTSef = document.getElementById('pluginRBTobjectSef');
  Main.networkPlugin = document.getElementById('networkPlugIn');
  Main.pluginRBTSef.Open("LFD", "1.000", "LFD");
  Main.checkNetworkStatus();
  setInterval(Main.checkNetworkStatus, 10000);

  // Enable key event processing
  Main.enableKeys();
  widgetAPI.sendReadyEvent();
};

Main.onUnload = function () {
  Main.pluginRBTSef.Close();
};

Main.enableKeys = function () {
  document.getElementById("anchor").focus();
};

Main.checkNetworkStatus = function () {

  try {
    if ((Main.networkPlugin.CheckPhysicalConnection(1) === 1 && Main.networkPlugin.CheckHTTP(1) === 1) || (Main.networkPlugin.CheckPhysicalConnection(0) === 1 && Main.networkPlugin.CheckHTTP(0) === 1)) {

      $.getJSON("appconf.json", function (data) {
        var url = data.DisplayUrl.toLocaleLowerCase();
        var storedUrl = "";
        if (!$.isEmptyObject(JSON.parse(Main.readDataFile()))) {
          storedUrl = JSON.parse(Main.readDataFile()).lastScreen.toLocaleLowerCase();
        }

        if (storedUrl.indexOf(url) === 0) {
          location.href = storedUrl;
        } else {
          location.href = url;
        }
      });

    } else {
      if ($('#offlinelayer').length === 0) {
        $('body').append('<div id="offlinelayer" style="background: rgba(255,255,255,.8);height: 100%;position: fixed;left: 0;top: 0;right: 0;right: 0;text-align: center;padding-top: 20%;color: black;font-size: 60px;line-height60px;z-index: 10;">Device is offline. Will try to reload shortly.</div>');
      }
    }
  } catch (err) {
    $('body').append(err);
  }
};

Main.rebootSystemCmd = function (str) {
  return Main.pluginRBTSef.Execute("rebootSystemCmd", str);
};

Main.keyDown = function () {
  var keyCode = event.keyCode;

  switch (keyCode) {
    case tvKey.KEY_RETURN:
    case tvKey.KEY_PANEL_RETURN:
      widgetAPI.sendReturnEvent();
      break;

    case tvKey.KEY_1:
      break;

    case tvKey.KEY_3:
      this.rebootSystemCmd("Reboot");
      break;

    default:
      break;
  }
};

/**
 * Serializes the object to JSON in a data file
 * @param {Object} data
 */
Main.writeToDataFile = function (data) {
  //make the test file, w+ makes the file, overwriting existing file
  var fo = Main._localFileSystem.openCommonFile(Main._dataFileCommonPath, 'w+');
  if (fo) {
    fo.writeAll(JSON.stringify(data));
    //close the file
    Main._localFileSystem.closeCommonFile(fo);
    //Main.log('Wrote to file: ' + Main._dataFileCommonPath);
  } else {
    //Main.log('Failed to write/create test file');
  }
};


/**
 * Reads the data file
 * @returns {String}
 */
Main.readDataFile = function () {
  //open the file to read
  var fo = Main._localFileSystem.openCommonFile(Main._dataFileCommonPath, 'r');
  if (fo != null) {
    //read the file
    var data = fo.readAll();
    //close the file
    Main._localFileSystem.closeCommonFile(fo);
    //Main.log('Successfully read file: ' + Main._dataFileCommonPath);
    return data;
  } else {
    //if this happens the file probably didnt exist
    //Main.log('Failed to read file: ' + Main._dataFileCommonPath);
    return '{}';
  }
};



