﻿$('#search-button').on('click', function () {
    $("form").toggle();
});
var goTo = null;
var page = document.location.hash;
$("#activities").on("pagebeforecreate", function (event) {
    if (page && page.length > 0) {
        goTo = page;
        $('#activities').css("visibility", "hidden");
    }
});

var template = Handlebars.compile($('#activity-list-item-template').html());
var templatePages = Handlebars.compile($('#activity-page-item-template').html());
var templatePagesCapacity = Handlebars.compile($('#activity-page-Capacity-template').html());
var templatePagesStatus = Handlebars.compile($('#activity-page-status-template').html());
var templatePagesstatusAndImage = Handlebars.compile($('#activity-page-statusAndImage-template').html());
var templatePagesDescription = Handlebars.compile($('#activity-page-Description-template').html());
var templatePagesMeetingTitle = Handlebars.compile($('#activity-page-MeetingTitle-template').html());
var templatePagesImagePath = Handlebars.compile($('#activity-page-ImagePath-template').html());
var refreshSec = 60;

Handlebars.registerHelper('periodText2', function (status) {
    var val = "";
    if (status.Period && status.Period.length > 0) {
        val = " " + (status.Free ? screenLocalization.AvailableFrom + " " : screenLocalization.OccupiedFrom + " ") + status.Period.replace('-', screenLocalization.To.toLowerCase());
    }
    return new Handlebars.SafeString(val);
});

Handlebars.registerHelper('periodText', function (status) {
    var val = "";
    if (status.Period && status.Period.length > 0) {
        val = status.Free ? screenLocalization.AvailableFrom : screenLocalization.OccupiedFrom;
        var dates = status.Period.split('-');
        
        var space = '&nbsp;';
        var spanFromWrap = getFirstUppercased(val);
        var paranthesStart = getFirstUppercased('(');
        var paranthesEnd = getFirstUppercased(')');
        var startDate = dates[0];
        var startDatePostFix = "";

        if (startDate.indexOf("pm") > -1 || startDate.indexOf("PM") > -1) {
            startDate = startDate.replace("pm", "").replace("PM", "");
            startDatePostFix = space + getOnlyUppercased('pm');
        }
        else if (startDate.indexOf("am") > -1 || startDate.indexOf("AM") > -1) {
            startDate = startDate.replace("am", "").replace("AM", "");
            startDatePostFix = space + getOnlyUppercased('am');
        }

        var endDate = dates[1];
        var endDatePostFix = "";
        if (endDate.indexOf("pm") > -1 || endDate.indexOf("PM") > -1) {
            endDate = endDate.replace("pm", "").replace("PM", "");
            endDatePostFix = space + getOnlyUppercased('pm');
        }
        else if (endDate.indexOf("am") > -1 || endDate.indexOf("AM") > -1) {
            endDate = endDate.replace("am", "").replace("AM", "");
            endDatePostFix = space + getOnlyUppercased('am');
        }
        var spanDateFromWrap = getAllUppercased(startDate) + startDatePostFix;
        var spanDateToWrap = getAllUppercased(endDate) + endDatePostFix;
        var spanToSymbolWrap = getOnlyUppercased(screenLocalization.To);
        val = paranthesStart + spanFromWrap + space + spanDateFromWrap + space + spanToSymbolWrap + space + spanDateToWrap + paranthesEnd;
    
    }
    return new Handlebars.SafeString(val);
});

function getTimeLeft(prefix, hours, minutes) {
    var reply = prefix;
    if (hours && hours > 0) {
        reply += " " + hours + " " + screenLocalization.HourShort + " ";
    }
    if (minutes && minutes > 0) {
        reply += " " + minutes + " " + screenLocalization.MinutesShort;
    }
    return reply;
};


Handlebars.registerHelper('capacityText', function (capacity) {
    var val = screenLocalization.Capacity + ": " + capacity;
    return new Handlebars.SafeString(val);
});

Handlebars.registerHelper('statusText', function (status) {
    var val = status.Free ? screenLocalization.AvailableNext : screenLocalization.EndsIn;
    if (val == screenLocalization.AvailableNext && status.HoursLeft == 0 && status.MinutesLeft == 0) {
        val = getFirstUppercased(screenLocalization.AvailableForTheRestOfTheDay);
    }
    else {
        val = val + " " + getTimeLeftFormated(status);
    }
    return new Handlebars.SafeString(val);
});

function getTimeLeftFormated(status) {
    return getTimeLeft('', status.HoursLeft, status.MinutesLeft);  
}

Handlebars.registerHelper('imagePath', function (path,id) {
    if (path && path.length > 0) {
        return new Handlebars.SafeString('<div id="image' + id + '" class="roomContainer" data-original="Image.mvc/Get/' + path + '" />');
    }
    else {
        return "";
    }
});


Handlebars.registerHelper('localizeBack', function () {
        return screenLocalization.Back;
});



Handlebars.registerHelper('statusClass', function (status) {
    var statusClass = status.Free ? "free" : "busy";
    return new Handlebars.SafeString(statusClass + "-row");
});

Handlebars.registerHelper('searchText', function () {
    var statusClass = this.Status.Free ? "free" : "busy";
    return new Handlebars.SafeString(statusClass + ':' + this.Name + ':' + this.Description);
});

function getAllUppercased(text) {
    return '<span style="display:inline-block" class="uppercased-allletter">' + text + '</span>';
}
function getFirstUppercased(text) {
    return '<span style="display:inline-block" class="uppercased-firstletter">' + text + '</span>';
}

function getOnlyUppercased(text) {
    return '<span style="display:inline-block" class="uppercased">' + text + '</span>';
}


var mainloaded = false;
var wrapper = null;
var screenInfo = null;
var imagePath = null;
$('#activities').on('pageshow', function (event) {
    if (!mainloaded) {
        $.mobile.loading('show');
    }
});


$('#activities').on('pageinit', function (event) {
    $.ajax({
        url: 'GetDisplayDataMobile/',
        success: function (data) {
            imagePath = getImagePath(data);
            wrapper = { objects: data.Items };
            screenInfo = data.ScreenInfo;
            drawElements();
            mainloaded = true;
          
        }
    });
});

function setElementVisibility() {
    var lis = $(".detail-list").children();
    $.each(lis, function () {
        if ($(this).html() != "") {
            $(this).show();
        }
        else {
            $(this).hide();
        }
    });
}

function drawElements() {
    if (goTo) {
        $("[id^='activity-details']").remove();
        $("body").append(templatePages(wrapper));
        doInitialization('1');

        if (goTo) {
            $.mobile.changePage($(goTo));
        }
        setTimeout(function () {
            updateListView();
            $.mobile.loading('hide');
            $('#activities').trigger('create');
            setTimeout(function () {
                $('#activities').css("visibility", "");
            }, 500);
        }, 10);
    }
    else {
        updateListView();
        $.mobile.loading('hide');
        $('#activities').trigger('create');

        setTimeout(function () {
            $("[id^='activity-details']").remove();
            $("body").append(templatePages(wrapper));
            doInitialization('2');
        }, 10);
        
    }
    $("form").hide();
}

function doInitialization(from) {
    generateClock();
    generateLogo();
    setElementVisibility();
    updateProgressBar();
    setStatus();

    $("[id^='activity-details']").on('pageshow', function () {
        showPageImageFor($(this).attr('id'));
    });
}

function showPageImageFor(pageId) {
    var id = "image" + pageId.replace("activity-details", "");
    var el = $('#' + id);
    var image = $('<img class="roomImage" />');
    if (el.data('original')) {
        image.attr('src', "../" + el.data('original'));
        el.empty();
        el.html(image);
    }
}

function setStatus() {
    var bars = $('.status-container');
    $.each(bars, function() {
        $(this).parent().removeClass("free-row").removeClass("busy-row").addClass($(this).data("status"));
    });
}

function updateProgressBar() {
    var bars = $('.progressbar');
    $.each(bars, function () {
        var indicator = $(this).children().first();
        var w = indicator.data("remaining");
        indicator.css("width", w + "%");
    });
}

function updateElements() {
    var showSearch = $("form:visible").length > 0;
    updateListView();

    setTimeout(function () {
        $.each(wrapper.objects, function (i, v) {
            if ($("#activity-details" + this.Id).length > 0) {
                $("#statusText" + this.Id).html(templatePagesStatus(this));
                $("#MeetingTitle" + this.Id).html(templatePagesMeetingTitle(this));
                $("#Description" + this.Id).html(templatePagesDescription(this));
                $("#statusAndImage" + this.Id).html(templatePagesstatusAndImage(this));
                $("#Capacity" + this.Id).html(templatePagesCapacity(this));
                $("#ImagePath" + this.Id).html(templatePagesImagePath(this));
            }
        });
        doInitialization('3');
        var page = document.location.hash;
        
        if (page && page.length > 0) {
            showPageImageFor(page.replace('#',""));
        }
    }, 10);
    $.mobile.loading('hide');
    $('#activities').trigger('create');
    
    if (!showSearch) {
        $("form").hide();
    }
}


function updateListView() {
    $("#ulEl").empty().html(template(wrapper));
    refreshListView();
}

function refreshListView() {
    $("#ulEl").listview('refresh');
}
function generateLogo() {
    if (imagePath && imagePath != '') {
        $("#MobileLogo").attr('src', '../Image.mvc/Get/' + imagePath);
    }
}

function generateClock() {
    $("#liclock").html(getTimeString(screenInfo).replace(":"," : ") + "&nbsp;&bull;&nbsp;" + getDateString(screenInfo));
/*    setHours();
    setMinutes();
    setDate();
    setPoint();*/
}

setInterval(function () {
    $.ajax({
        url: 'GetDisplayDataMobile/',
        success: function (data) {
            imagePath = getImagePath(data);
            wrapper = { objects: data.Items };
            screenInfo = data.ScreenInfo;
            updateElements();
            doInitialization('4');
            //generateClock();
        }
    });
}, refreshSec * 1000);

function getImagePath(data) {
    
    if (data && data.ScreenInfo && data.ScreenInfo.ScreenDetail && data.ScreenInfo.ScreenDetail.Logo) {
        return data.ScreenInfo.ScreenDetail.Logo;
    } else {
        return null;
    }
}

function getTimeString(screenInfo) {
    var timeUtility = new TimeUtility();
    var timeFormat = timeUtility.convertFromDotNet(screenInfo.TimeInfo.TimeFormat);
    var currentTime = timeUtility.createTime(screenInfo.TimeInfo.SeedTime);

    return timeUtility.formatTime(timeFormat, currentTime);
}

function getDateString(screenInfo) {
    var timeUtility = new TimeUtility();
    var timeFormat = timeUtility.convertFromDotNet(screenInfo.TimeInfo.DateFormat);
    var currentTime = timeUtility.createTime(screenInfo.TimeInfo.SeedTime);

    return timeUtility.formatTime(timeFormat, currentTime, null);
}

$.mobile.defaultPageTransition = 'none';